SystemOrganization addCategory: #Deli!
SystemOrganization addCategory: #'Deli-models'!
SystemOrganization addCategory: #'Deli-configuration'!
SystemOrganization addCategory: #'Deli-frontend'!
SystemOrganization addCategory: #'Deli-announcements'!
SystemOrganization addCategory: #'Deli-tutorial'!
SystemOrganization addCategory: #'Deli-util'!
SystemOrganization addCategory: #'Deli-tests'!

HPISession subclass: #DLSession
	instanceVariableNames: 'user announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:04'!
announcer
	^ announcer ifNil: [ announcer := Announcer new. ].! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:03'!
charSet
	^ 'iso-8859-1'! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 00:11'!
login: aUsername
	super login: aUsername.
	self user: (DLUser getOrCreateFrom: {#userName -> self username}).! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/10/2009 18:10'!
logout
	self expire.
	self user: nil.
	super logout.! !

!DLSession methodsFor: 'accessing' stamp: 'sebh 6/24/2009 12:09'!
user
	^ user ifNil: [^ user := (DLUser getOrCreateFrom: {#userName -> self username})]! !

!DLSession methodsFor: 'accessing' stamp: 'Marik 5/20/2009 17:08'!
user: anObject

	user := anObject.! !

MATextInputComponent subclass: #DLMALinkComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkComponent class methodsFor: 'as yet unclassified' stamp: 'cr 7/13/2009 14:41'!
isAbstract
	^false! !

!DLMALinkComponent methodsFor: 'as yet unclassified' stamp: 'cr 7/13/2009 14:42'!
renderViewerOn: html
	html withUrls: self value! !

MAComponentRenderer subclass: #DLCssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderContainer: aDescription 
	html definitionList
		class: (self classFor: aDescription);
		with: [ super renderContainer: aDescription ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderControl: aDescription
	html definitionData
		class: (self classFor: aDescription);
		with: [ super renderControl: aDescription.
				  html div class:'helptext'; with: aDescription comment.
			 ]! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderGroup: aDescription
	super renderGroup: aDescription.
	group isNil ifTrue: [ ^ self ].
	html definitionTerm
		class: 'group';
		with: group! !

!DLCssRenderer methodsFor: 'rendering' stamp: 'sebh 6/8/2009 00:21'!
renderLabel: aDescription
	html definitionTerm
		title: aDescription comment;
		class: (self classFor: aDescription);
		with: [ super renderLabel: aDescription ]! !

MAExternalFileModel subclass: #DLMAExternalFileModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:33'!
calcFilesize
	filesize := self contents size.! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:35'!
filesize: aFilesize
	"Allow to manually set filesize so we can save it somewhere else."
	filesize := aFilesize.! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/14/2009 01:30'!
isEmpty
	^ location isEmpty! !

!DLMAExternalFileModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/19/2009 00:04'!
location: aLocation
	| directory |
	location := aLocation.
	directory := self baseDirectory.
	directory assureExistence.
	aLocation do: [:each |
		directory := directory directoryNamed: each.
		directory assureExistence.
	]! !

Announcement subclass: #DLLogoutAnnouncement
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

Announcement subclass: #DLViewCompReplacement
	instanceVariableNames: 'component'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-announcements'!

!DLViewCompReplacement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:57'!
forComponent: aComponent
	^ self new
		component: aComponent;
		yourself.! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component

	^ component! !

!DLViewCompReplacement methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:55'!
component: anObject

	component := anObject.! !

HPIAuthMain subclass: #DLAuthMain
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthMain methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 23:33'!
createRoot
	^ super createRoot
		addDecoration: DLAuthentication new;
		yourself! !

HPIAuthentication subclass: #DLAuthentication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLAuthentication methodsFor: 'as yet unclassified' stamp: 'sebh 6/10/2009 13:12'!
verifyPassword: password forUser: username
	^ self session isLoggedIn or: [
			(username = 'jack') | (username = 'john')
			ifTrue: [self session login: username]
			ifFalse:[super verifyPassword: password forUser: username].
			self session isLoggedIn]! !

TestCase subclass: #DLGenericModelTests
	instanceVariableNames: 'session'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session

	^ session! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 11:53'!
session: anObject

	session := anObject.! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:26'!
setUp
	| |
	super setUp.
	SqsConnectionManager reset.
	self session: (SqsConnectionManager getInstance sessionForClass: DLTestModel).
	self session resetDatabase.
	

	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:06'!
tearDown
	| |
	super tearDown.

	! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/12/2009 18:44'!
testCollectionLogging
	| model item |
	model := DLTestModel createFrom: {
		#title->'A nice title'. 
		#items->{
			DLTestItemModel createFrom:{#title->'Nummer 1'}.
			DLTestItemModel createFrom:{#title->'Nummer 2'}.
			} asOrderedCollection.
		}.
		
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'Saving a new item should result in a log entry'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'title']]) size = 1]
		  description: 'Make sure the created changes include #title'.
		self assert: [((SqsSearch for: DLLogEntry) select: [:anEntry | anEntry changes anySatisfy: [:aChange | aChange attributeName = 'items']]) size = 1]
		  description: 'Make sure the created changes include #items'.
	self assert: [((SqsSearch for: DLLogEntry) select: [:aChange | aChange changes size = 3]) size = 1]
			description: '3 changes should have been recorded: Changed title + 2 added elements'.
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1]
		  description: 'Since nothing changed, no new log should be created'.
	item := DLTestItemModel createFrom:{#title->'Nummer 3'}.
	model items add: (item).
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2]
		  description: 'Collection changed, a new log entry should be created'.
	model items remove: item.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 3]
		  description: 'Collection changed, a new log entry should be created'.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:10'!
testCollectionProxyProtection
	| model item item2 |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: [model items class includesBehavior: SqsProxy] 
	     description: 'After #save, collections should be proxied'.
	item2 := DLTestItemModel createFrom: {#title->'Test2'}.
	model items: (OrderedCollection with: item2).
	self assert: [model items class includesBehavior: SqsProxy] 
		  description: 'Trying to replace a proxied collection just adds and removes differences but does not replace the original list'.! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 7/9/2009 10:37'!
testCollectionProxying
	| model item |
	item := DLTestItemModel createFrom: {#title->'Test'}.
	model := DLTestModel newFrom: {
		#title->'A nice title'.
		#items->(OrderedCollection with: item)
	}.
	model save.
	self assert: (model items class includesBehavior: SqsProxy)! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/27/2009 18:59'!
testCreateFrom
	| model model2 |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves an object to a database'.
	model2 := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'CreateFrom saves another object to a database, doesnt care about identity'.
	self assert: [ model ~= model2 ] description: 'Objects should not be equal'.! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/27/2009 19:13'!
testGetOrCreateFrom
	| model model2 model3 |
	model := DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [ model oid notNil ] description: 'GetOrCreateFrom saves an object to a database, if it didnt exist before'.
	model2:= DLTestModel getOrCreateFrom: {#title->'A nice title'}.
	self assert: [model = model2] description: 'Same parameters lead to the same object.'.
	model3:= DLTestModel getOrCreateFrom: {#title->'A nice title'. #body->'Same title, but given text'}.
	self assert: [model2 ~= model3] description: 'Different parameters will create a new object'.	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:24'!
testGetOrCreateFromColisions
	| model1 model2 |
	model1 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'A body'}.
	model2 := DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> 'Another body'}.
	self assert: [ model1 ~= model2 ] description: 'Different parameters should create different objects'.
	self should: [ DLTestModel getOrCreateFrom: {  (#title -> 'A nice title')  } ]
		  raise: DLMultipleResultsException
		  description: '"A nice title" is set for two objects, thus it is not possible to return a single object that fits the array'! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 6/30/2009 18:21'!
testGetOrCreateNil
	self should: [ DLTestModel getOrCreateFrom: {#title -> 'A nice title'. #body -> nil} ]
		  raise: DLNilValueException
		  description: 'We do not retrieve objects for nil which is to be treated as uncertain value'! !

!DLGenericModelTests methodsFor: 'accessing' stamp: 'sebh 6/30/2009 18:25'!
testLogging
	| model logEntry |
	model := DLTestModel createFrom: {#title->'A nice title'}.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
		  description: 'A newly created model with tracked fields creates a log entry'.
	logEntry := (SqsSearch for: DLLogEntry) findAll first.
	self assert: [ (logEntry klassName = 'DLTestModel') & (logEntry oid = model oid) ] 
		  description: 'A new logentry with corresponding info was created'.
	model save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 1] 
	     description: 'Having changed nothing, we dont create a new log entry'.
	model title: 'Another title'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a tracked instvar, we create a new log entry'.
	model body: 'Somebody!!'; save.
	self assert: [(SqsSearch for: DLLogEntry) findAll size = 2] 
	     description: 'Having changed a nontracked instvar, we dont create a new log entry'.
	! !

!DLGenericModelTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/10/2009 16:18'!
testNewFrom
	| model |
	model := DLTestModel newFrom: {#title->'A nice title'. #items->{'item 1'. 'item 2'}}.
	self assert: [ model title = 'A nice title'] description: 'Correct model title'.
	self assert: [ model items =(OrderedCollection newFrom:{'item 1'. 'item 2'})] description: 'Correct model item collection'.
	self assert: [ model oid isNil ] description: 'newFrom does not invoke a database save'.! !

TestCase subclass: #DLPolicyTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testCanonicalName
	Tutorials new DatabaseFixture.
	DLModel allInstancesDo: [:instance| 
		self assert: [instance perform: #canonicalName notNil]
			  description: instance className, ' does not properly implement #canonicalName (returns nil)'
		]
	! !

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaName
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaName) notEmpty]
			  description: subclass name, ' does not properly implement #metaName (is empty)'
		]! !

!DLPolicyTests methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:31'!
testMetaNamePlural
	DLModel allSubclassesDo: [:subclass| 
		self assert: [(subclass perform: #metaNamePlural) notEmpty]
			  description: subclass name, ' does not properly implement #metaNamePlural (is empty)'
		]! !

WAComponent subclass: #DLComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLComponent subclass: #DLAdminConfirmDeleteComp
	instanceVariableNames: 'deleteElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminConfirmDeleteComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 11:04'!
for: anElement
	^ self new
		deleteElement: anElement;
		yourself.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement

	^ deleteElement! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:12'!
deleteElement: anObject

	deleteElement := anObject.! !

!DLAdminConfirmDeleteComp methodsFor: 'accessing' stamp: 'sebh 6/15/2009 11:14'!
permissionCheck
	^ self session user isAdmin! !

!DLAdminConfirmDeleteComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/20/2009 23:48'!
renderContent: html
	html text: 'Mchten sie "', self deleteElement asString, '" wirklich lschen?'; break.
	self renderDependencies: html.
	html anchor 
				callback: [self answer: true];
				text: 'Ja'.
	html break.
	html anchor
				callback: [self answer: false];
				text: 'Nein'.! !

!DLAdminConfirmDeleteComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/20/2009 23:56'!
renderDependencies: html
	|dependencies|
	dependencies := self deleteElement collectDependencies.
	html paragraph: 'Folgende Element werden durch bestehende Abhngigkeiten ebenfalls gelscht'.
	html unorderedList:
		[
			dependencies do: [:aDependency | 
				html listItem: [
					html span class: 'className'; with: aDependency class metaName.
					html anchor
						callback: [self call: (DLAdminDetailComp for: aDependency)];
						text: aDependency canonicalName.
						
				]	
			]
		] ! !

DLComponent subclass: #DLChartComp
	instanceVariableNames: 'count max'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLChartComp class methodsFor: 'as yet unclassified' stamp: 'Marik 7/1/2009 12:10'!
count: aCount of: aMaxValue

	^self new
		count: aCount;
		max: aMaxValue;
		yourself.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count

	^ count! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
count: anObject

	count := anObject.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max

	^ max! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:06'!
max: anObject

	max := anObject.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 12:14'!
permissionCheck
	^ self session isLoggedIn.! !

!DLChartComp methodsFor: 'accessing' stamp: 'Marik 7/1/2009 15:17'!
renderContent: html
	| perCent perCentString|
	perCent := self count / self max * 100.
	perCentString := perCent asString, '%'.
	html text: 'Fortschritt: ';
		  text: self count asString, '/', self max asString, ' Abgaben sind komplett.'.
	html div class:'graph';	  with: [html strong class:'bar'; style:'width: ', perCent asString,'%;'; 
												with: [html text: perCentString]].! !

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
permissionCheck

	^ false.! !

!DLComponent methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:29'!
renderContent: html

	self subclassResponsibility! !

!DLComponent methodsFor: 'accessing' stamp: 'Marik 7/13/2009 15:42'!
renderContentOn: html
	self permissionCheck 
		ifTrue: [self renderContent: html.]
		ifFalse:[html div with: 'Permission denied']
	! !

DLComponent subclass: #DLDetailComp
	instanceVariableNames: 'detailElement additionalComps'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLDetailComp subclass: #DLAdminDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDetailComp methodsFor: 'as yet unclassified' stamp: 'Marik 6/4/2009 21:21'!
permissionCheck

	^ self session user isAdmin! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'MG 6/5/2009 15:28'!
for: anDetailElement

	^self new
		detailElement: anDetailElement;
		yourself.! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 17:16'!
for: anDetailElement additionalComp: aComponent
	^self for: anDetailElement additionalComps: {aComponent}! !

!DLDetailComp class methodsFor: 'as yet unclassified' stamp: 'cr 6/6/2009 17:15'!
for: anDetailElement additionalComps: aComponentList

	|new|
	new := self new
		detailElement: anDetailElement.
	new additionalComps addAll: aComponentList.
	^ new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps
	^ additionalComps! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:39'!
additionalComps: anObject 
	additionalComps := anObject! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:44'!
children
	^ self additionalComps asArray.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement

	^ detailElement! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:09'!
detailElement: anObject

	detailElement := anObject.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 6/6/2009 16:44'!
initialize

	super initialize.
	self additionalComps: OrderedCollection new.! !

!DLDetailComp methodsFor: 'accessing' stamp: 'Marik 6/4/2009 21:14'!
permissionCheck
	
	^ self session isLoggedIn! !

!DLDetailComp methodsFor: 'accessing' stamp: 'sebh 7/12/2009 03:07'!
renderActions: html
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [| answer |
					answer := self call: (self detailElement descriptionUpdate asComponentOn: self detailElement) addValidatedForm.
					answer ifNotNil: [self detailElement save]];
				text: 'Bearbeiten'.
			].
		self detailElement trackChangeVariables ifNotEmpty: [
			html anchor
				callback: [ self call: (DLListComp for: DLLogEntry 
					 										  with: {#klassName->self detailElement className. #objectId->self detailElement oid}
			 	  )];
				text: 'Vernderungen'.
			].
		html anchor
			callback: [self answer: true];
			text: 'Zurck'.
		].
	
! !

!DLDetailComp methodsFor: 'accessing' stamp: 'caro 7/9/2009 14:33'!
renderContent: html
	html heading: (self detailElement class metaName,': ',self detailElement canonicalName) level: 2.
	self renderActions: html.
	html div: [
		html definitionList with: [
			self detailElement descriptionDetail do: [:desc |
				html definitionTerm: desc label.
				html definitionData: (desc toString: (desc accessor read: (self detailElement))).
	]]].
	self additionalComps do: [:each | 
		html div with: each.
	].! !

DLDetailComp subclass: #DLUserDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserDetailComp subclass: #DLUserDeliveryDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeliveryDetailComp class methodsFor: 'as yet unclassified' stamp: 'Marik 7/1/2009 09:50'!
for: aDeadline user: aUser
	| group delivery deliverables |
	group := aUser groupForLecture: aDeadline lecture.
	delivery := DLDelivery getOrCreateFrom: {#group -> group. #deadline -> aDeadline.}.
	deliverables := OrderedCollection new.
	delivery deliverables do: [:aDeliverable | deliverables add: (aDeliverable descriptionUpdate asComponentOn: aDeliverable) addValidatedForm].
	^ self for: delivery additionalComps: deliverables! !

!DLUserDeliveryDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:05'!
permissionCheck
	
	^ (self session isLoggedIn) & (self detailElement deadline isNotExpired) ! !

!DLUserDeliveryDetailComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/1/2009 09:50'!
renderContent: html
	self renderActions: html.
	html definitionList with: [
		self detailElement descriptionDetail do: [:desc |
			html definitionTerm: desc label.
			html definitionData: (desc accessor read: (self detailElement))
		]
	].
	self additionalComps do: [:each | 
		html div with: each
	].! !

!DLUserDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:17'!
renderActions: html
	! !

DLUserDetailComp subclass: #DLUserLectureDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureDetailComp methodsFor: 'as yet unclassified' stamp: 'Marik 6/29/2009 16:25'!
renderActions: html
	html div class: 'actions'; with: [
		html anchor
			callback: [|answer group|
					group := DLGroup newFrom: {#lecture->self detailElement}.
					answer := self call: (group descriptionUpdate asComponentOn: group) addValidatedForm.
					answer ifNotNil: [group save]];
			text: 'Gruppe anlegen'.
		].! !

DLUserDetailComp subclass: #DLUserProfileDetailComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserProfileDetailComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 01:00'!
renderActions: html
	"Duplicate from DLDetailComp"
	html div class: 'actions'; with: [
		(self detailElement rightUpdate: self session user) ifTrue: [
			html anchor
				callback: [|answer|
					answer := self call: (self detailElement descriptionUserUpdate asComponentOn: self detailElement) addValidatedForm.
					answer ifNotNil: [self detailElement save]];
				text: 'Bearbeiten'.
			].
		].! !

DLComponent subclass: #DLListComp
	instanceVariableNames: 'listClass magritteReport collectionFields valueFields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLListComp subclass: #DLAdminListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminListComp subclass: #DLAdminDeadLineListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeadLineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:23'!
columnDetail
^ (MACommandColumn new
			addCommand: [:listElement |
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLChartComp count: listElement countDeliveriesComplete of: 10).(DLAdminDeliveryListComp with: {#deadline->listElement}).}
					)
			]
			text: 'Details';
			yourself).! !

!DLAdminDeadLineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:29'!
listClass
	^ DLDeadline! !

DLAdminListComp subclass: #DLAdminDeliveryListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminDeliveryListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:34'!
columnDetail
| detailBlock |
detailBlock := [:listElement | 
					self call: (
						DLAdminDetailComp for: listElement 
							additionalComps: {(DLAdminListComp for: DLDeliverable with: {#delivery->listElement}).}
					)].
^ (DLMAConditionalCommandColumn new
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete]
			text: 'Komplett';
			addCommand: detailBlock
			condition: [:listElement| listElement isComplete not]
			text: 'Nicht komplett';
			yourself).! !

!DLAdminDeliveryListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:36'!
listClass
	^ DLDelivery! !

!DLAdminDeliveryListComp methodsFor: 'as yet unclassified' stamp: 'Marik 7/1/2009 15:30'!
listObjects
	"Precreate all Deliveries for a given lecture"
	| deadline |
	deadline := self valueFieldsAt: #deadline.
	deadline ifNotNil: [ 
		| groups |
		groups := (SqsSearch for: DLGroup) select: [:aGroup | (aGroup lecture) = (deadline lecture)].
		groups do: [:aGroup | 
			DLDelivery getOrCreateFrom: {#deadline->deadline. #group->aGroup}.	
		]
	].
	^ super listObjects.
	! !

DLAdminListComp subclass: #DLAdminLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminLectureListComp methodsFor: 'as yet unclassified' stamp: 'caro 7/13/2009 19:26'!
columnDetail
	^ MACommandColumn new
		addCommand: 
				[ :listElement | 
				self call: (DLAdminDetailComp 
						for: listElement
						additionalComps: { 
								(DLAdminListComp 
									for: DLDeadline
									with: {  (#lecture -> listElement)  }).
								(DLAdminListComp 
									for: DLGroup
									with: {  (#lecture -> listElement)  }).
								(DLAdminGrouplessUserListComp for: listElement)
							 }) ]
			text: 'Details';
		yourself! !

!DLAdminLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 17:34'!
listClass
	^ DLLecture.! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:18'!
deleteComponent
	^DLAdminConfirmDeleteComp! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:25'!
detailComponent
	^DLAdminDetailComp! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:39'!
listDescription
	^ (self listClass) new descriptionAdminList! !

!DLAdminListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 17:01'!
permissionCheck
	^ self session user isAdmin! !

DLAdminListComp subclass: #DLAdminTopicListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminTopicListComp class methodsFor: 'as yet unclassified' stamp: 'caro 7/3/2009 22:04'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLAdminTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/26/2009 01:09'!
columnDetail
	^ (MACommandColumn new
			addCommand: [:listElement |
					self call: (
						DLAdminDetailComp for: listElement 
							"additionalComps: {(DLAdminListComp for: DLDeadline with: {#lecture->listElement}). 
													(DLAdminListComp for: DLGroup 	with: {#lecture->listElement})}"
					)
			]
			text: 'Details';
			yourself).! !

!DLAdminTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/26/2009 01:08'!
listClass
	^ DLTopic.! !

!DLAdminTopicListComp methodsFor: 'accessing' stamp: 'sebh 7/13/2009 23:37'!
user

	^ user! !

!DLAdminTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user: anObject

	user := anObject.! !

DLAdminListComp subclass: #DLAdminUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLAdminUserListComp subclass: #DLAdminGrouplessUserListComp
	instanceVariableNames: 'lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminGrouplessUserListComp class methodsFor: 'as yet unclassified' stamp: 'caro 7/12/2009 17:40'!
for: aLecture
	^ self new
		lecture: aLecture;
		yourself.! !

!DLAdminGrouplessUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:28'!
columnGroup
	^ (MACommandColumn new
			addCommand: [:listElement | 
				|answer lectures|
				lectures := OrderedCollection with: self lecture.
				answer := self call: (DLUserJoinGroupComp for: listElement with: lectures).
				self refreshReport.
				]
			text: 'Gruppieren';
			yourself) ! !

!DLAdminGrouplessUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:43'!
grouplessUser
	 |answer students|
	students := OrderedCollection new.
	answer := OrderedCollection new.
	students := (lecture students).
	students do:[:anElement |
		(anElement groupForLecture: lecture) ifNil: [answer add: anElement]].
	"Better something along those lines:
		^ self students collect: [:aStudent | (aStudent groupForLecture: self lecture) ifNil: [aStudent]].
	"
	^ answer! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture

	^ lecture! !

!DLAdminGrouplessUserListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:33'!
lecture: anObject

	lecture := anObject.! !

!DLAdminGrouplessUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:44'!
listObjects
	|answer|
	"^ (lecture students)" 
	answer := (self grouplessUser).
	^ answer! !

!DLAdminUserListComp methodsFor: 'as yet unclassified' stamp: 'caro 7/13/2009 19:27'!
columnEmail
	^ (MACommandColumn new 
			addCommand: [:aListElement | 
				|answer mail receivers| 
				mail := DLMail new.
				mail sender: self session user email.
				receivers := OrderedCollection new.
				receivers add: aListElement email. 
				mail receiversAsCollection: receivers.
				answer := self call: (mail description asComponentOn: mail) addValidatedForm.
				answer ifNotNil: [answer sendMail].
				self refreshReport.]
			text: 'Email'
			yourself).! !

!DLAdminUserListComp methodsFor: 'as yet unclassified' stamp: 'caro 7/13/2009 19:27'!
listClass
	^ DLUser.! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/6/2009 00:26'!
for: aListElement
	^ self new
		listClass: aListElement;
		yourself.! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'Marik 6/18/2009 17:34'!
for: aClass with: anObjectDict
	"Given a dictionary of #fieldname to object, this method constructs a query."
	| newlist inspect |
	newlist := self new.
	newlist listClass: aClass.
	inspect := aClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:50'!
with: anObjectDict
	| newlist inspect |
	newlist := self new.
	inspect := newlist listClass new.
	anObjectDict do: [:pair | 
			(inspect perform: pair key) isCollection
			ifTrue: [ newlist collectionFields add: pair ]
			ifFalse:[ newlist valueFields add: pair ].
		].
	^ newlist.! !

!DLListComp methodsFor: 'columns' stamp: 'Marik 7/3/2009 10:43'!
actions
	^ {
		(self listClass rightCreate: self session user) ->	
			((self listClass metaName ,' anlegen')->[|answer listElement|
				listElement := self listClass newFrom: self valueFields.
					answer := self lightbox: (listElement descriptionCreate asComponentOn: listElement) addValidatedForm.
					answer ifNotNil: [listElement save].
					self refreshReport])
	}! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/18/2009 14:42'!
additionalActions
	^ {}! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 14:47'!
additionalColumns
	^ {}! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/18/2009 21:57'!
call: someComponent
	"Refresh list after a call to another component, values might have changed."
	| result |
	result := super call: someComponent.
	self refreshReport.
	^ result! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:26'!
children

	^ Array with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields

	^ collectionFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
collectionFields: anObject

	collectionFields := anObject.! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 7/13/2009 23:32'!
columnDelete
	^ (MACommandColumn new 
			addCommand: [:listElement | |answer| 
				answer := self call: (self deleteComponent for: listElement).
				answer ifTrue: [listElement destroy].
				self refreshReport.
				]  
			text:'Lschen'; 
			yourself).	! !

!DLListComp methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:00'!
columnDetail
	^ (MACommandColumn new 
			addCommand: [:listElement | self call: (self detailComponent for: listElement)]  
			text:'Details'; 
			yourself).	! !

!DLListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:15'!
columnGroup
	^ nil! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:23'!
columnUpdate
	^ (MACommandColumn new
			addCommand: [:listElement | 
				|answer| 
				answer := self lightbox: (listElement descriptionUpdate asComponentOn: listElement) addValidatedForm.
				answer ifNotNil: [listElement save].
				self refreshReport.
				]
			text: 'Bearbeiten';
			yourself) ! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 7/14/2009 00:26'!
columns
	| cols |
	cols := OrderedCollection new.
	(self listClass rightDetail: self session user) ifTrue: [ cols add: self columnDetail. ].
	(self listClass rightUpdate: self session user) ifTrue: [ cols add: self columnUpdate. ].
	(self listClass rightDelete: self session user) ifTrue: [ cols add: self columnDelete. ].
	(self listClass rightDelete: self session user) ifTrue: [ cols add: self columnGroup. ].
	cols addAll: self additionalColumns.
	^ cols select: [:aColumn | aColumn ~= nil ] ! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 7/13/2009 23:30'!
deleteComponent
	^DLAdminConfirmDeleteComp ! !

!DLListComp methodsFor: 'columns' stamp: 'sebh 6/13/2009 19:21'!
detailComponent
	^DLDetailComp! !

!DLListComp methodsFor: 'initialize-release' stamp: 'sebh 6/13/2009 21:18'!
initialize
	super initialize.
	self valueFields: OrderedCollection new.
	self collectionFields: OrderedCollection new.! !

!DLListComp methodsFor: 'report' stamp: 'sebh 7/3/2009 00:01'!
initializeReport
	self magritteReport: (self reportClass rows: self listObjects
							 	  description: self listDescription).
	self magritteReport 
	   batchSize: 50;
		showCaption: true;
		tableCaption: self listClass metaNamePlural;
		showSummary: false;
		tableSummary: self valueFields.
	self columns do: [:each | self magritteReport addColumn: each].! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass

	^ listClass! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:33'!
listClass: anObject

	listClass := anObject.! !

!DLListComp methodsFor: 'report' stamp: 'cr 6/6/2009 17:26'!
listDescription

	^ (self listClass) new descriptionList! !

!DLListComp methodsFor: 'report' stamp: 'Marik 6/24/2009 13:38'!
listObjects
	| allElements |
	allElements := ((SqsSearch for: self listClass) select: self listSelectBlock).
	allElements := allElements select: [:anObject |
		"Get all objects that have been selected by for:with: - TODO: Move this to query"
		|truth|
		truth := true.
	   self collectionFields do: 
			[:field | ((anObject perform: field key) includes: (field value)) ifFalse: [truth := false] ].
		self valueFields do:
			[:field | ((anObject perform: field key) = (field value)) ifFalse: [truth := false]].
		truth.
	].
	^allElements.! !

!DLListComp methodsFor: 'report' stamp: 'sebh 6/13/2009 18:40'!
listSelectBlock
	^[:anObject | ]
	! !

!DLListComp methodsFor: 'report' stamp: 'Marik 6/18/2009 17:48'!
magritteReport
	"Lazily initialize report"
	magritteReport ifNil: [self initializeReport].
	^ magritteReport! !

!DLListComp methodsFor: 'accessing' stamp: 'MG 6/5/2009 15:23'!
magritteReport: anObject

	magritteReport := anObject.! !

!DLListComp methodsFor: 'rights' stamp: 'sebh 6/6/2009 17:00'!
permissionCheck
	^ self session isLoggedIn.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/21/2009 00:27'!
refreshReport
	|return|
	return := self listObjects.
	self magritteReport rows: return.! !

!DLListComp methodsFor: 'rendering' stamp: 'sebh 6/20/2009 22:18'!
renderActions: html
	html div class: 'actions'; with: [
		
		(self actions, self additionalActions) do: [:each |
			| permission text callback |
			permission := each key. text := each value key. callback := each value value.
			permission ifTrue: [		
				html anchor
					callback: callback;
					text: text
				]
			] separatedBy: [html space.]
		].! !

!DLListComp methodsFor: 'rendering' stamp: 'Marik 6/24/2009 14:04'!
renderContent: html
	self renderActions: html.
	html div with: self magritteReport.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:11'!
reportClass
	^ MAReport! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields

	^ valueFields! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 17:41'!
valueFields: anObject

	valueFields := anObject.! !

!DLListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 22:57'!
valueFieldsAt: aKey
	| temp |
	temp := valueFields select: [:each | each key = aKey ].
	^ temp first value.! !

DLListComp subclass: #DLUserListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserListComp subclass: #DLUserDeadlineListComp
	instanceVariableNames: 'user an'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserDeadlineListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:24'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 13:59'!
for: aListElement user: aUser
	^ self new
		listClass: aListElement;
		user: aUser;
		yourself.! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'sebh 7/13/2009 23:46'!
additionalColumns
	"Checks whether a Deadline already is run out"
	| detailBlock |
	detailBlock := [:listElement | self call: (DLUserDeliveryDetailComp 
							for: listElement
							user: self session user) ].
	^ {(DLMAConditionalCommandColumn new
			addCommand: detailBlock
			condition:  [:listElement | listElement isNotCritical]
			text: 'Abgabe';
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isCritical]
			text: 'Abgabe'
			classed: 'warning';
			
			addCommand: detailBlock
			condition:  [:listElement | listElement isExpired]
			text: 'Deadline abgelaufen'
			classed: 'over';

			yourself).}! !

!DLUserDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:22'!
listClass
	^ DLDeadline! !

!DLUserDeadlineListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/18/2009 22:13'!
listObjects
	
	| result lectures groups |
	result := OrderedCollection new.
	lectures  := (SqsSearch for: DLLecture) select: [:aLecture  | aLecture students includes: self user].
	groups 	 := (SqsSearch for: DLGroup)   select: [:aGroup    | aGroup students includes: self user].

	result    := ((SqsSearch for: DLDeadline) findAll) 
						select: [:aDeadline | 
							| truth |
							truth := false.
							lectures do: [:aLecture | aLecture       = aDeadline lecture ifTrue: [truth:=true]].
							groups   do: [:aGroup   | aGroup lecture = aDeadline lecture ifTrue: [truth:=true]].
							truth].
	^result! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user

	^ user! !

!DLUserDeadlineListComp methodsFor: 'accessing' stamp: 'Marik 6/9/2009 13:59'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserGroupListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserGroupListComp class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 15:31'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:44'!
additionalActions
	^ {
		true -> ('Einer Gruppe beitreten'->[self call: (DLUserJoinGroupComp for: self user with: self user lectures)])
	}! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:39'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			addCommand:
					[ :listElement | self call: (DLLeaveTask for: listElement) ]
			condition: 
					[ :listElement | listElement lecture groupingPhaseActive ]
			text: 'Verlassen';
			yourself)
		}! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 18:12'!
listClass
	^ DLGroup! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 17:31'!
listSelectBlock
	^ [:aGroup | (aGroup students) includes: (self session user)]! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user

	^ user! !

!DLUserGroupListComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 15:27'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserJoinGroupComp
	instanceVariableNames: 'user lecture'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserJoinGroupComp class methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:57'!
for: aUser with: aLecture
	^ self new
		user: aUser;
		lecture: aLecture;
		yourself.! !

!DLUserJoinGroupComp methodsFor: 'as yet unclassified' stamp: 'caro 7/12/2009 19:51'!
additionalColumns
	^ { 
		(MACommandColumn new
			addCommand: 
				[ :listElement | self call: (DLJoinTask for: (self user) with: listElement) ]
			text: 'whlen';
			yourself)
	 }.! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:32'!
initializeReport
	super initializeReport.
	self magritteReport groupField: #lecture.! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:42'!
lecture

	^ lecture! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:42'!
lecture: anObject

	lecture := anObject.! !

!DLUserJoinGroupComp methodsFor: 'as yet unclassified' stamp: 'caro 6/18/2009 21:50'!
listClass
	^ DLGroup! !

!DLUserJoinGroupComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:55'!
listObjects
	^ (SqsSearch for: DLGroup) findAll select: [:aGroup | aGroup lecture = self lecture].! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:29'!
reportClass
	^ DLMAGroupedReport ! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user

	^ user! !

!DLUserJoinGroupComp methodsFor: 'accessing' stamp: 'caro 6/18/2009 19:04'!
user: anObject

	user := anObject.! !

DLUserListComp subclass: #DLUserLectureListComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:59'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserLectureListComp with: {#students->self session user})]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: 'Beitreten';
			addCommand: [:listElement | listElement removeStudent: self session user]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: 'Verlassen';
			yourself).}! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 23:55'!
columnDetail
	^ (MACommandColumn new
			addCommand: [:listElement |
					self call: (
						DLUserDetailComp for: listElement 
							additionalComps: {(DLUserListComp for: DLDeadline with: {#lecture->listElement. #group->nil}). 
													(DLUserListComp for: DLGroup 	with:   {#lecture->listElement}).
													(DLUserListComp for: DLTopic 	with:   {#lecture->listElement}).}
					)
			]
			text: 'Details';
			yourself).! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/18/2009 14:54'!
detailComponent
	^ DLUserLectureDetailComp! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:36'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Noch keiner ', self listClass metaName, ' beigetreten.'! !

!DLUserLectureListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:11'!
listClass
	^ DLLecture! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/23/2009 18:01'!
actions 
	^ {}! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:12'!
columnDelete
	^ nil! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:15'!
columnUpdate
	^ nil! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 23:13'!
detailComponent
	^ DLUserDetailComp! !

!DLUserListComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/23/2009 18:00'!
listDescription
	^ (self listClass) new descriptionUserList! !

DLUserListComp subclass: #DLUserTopicListComp
	instanceVariableNames: 'user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserTopicListComp class methodsFor: 'as yet unclassified' stamp: 'caro 7/3/2009 22:04'!
for: aUser
	^ self new
		user: aUser;
		yourself.! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:31'!
additionalColumns
	^ {(DLMAConditionalCommandColumn new
			addCommand: [:listElement | listElement addStudent: self session user. self call: (DLUserTopicListComp with: {#students->self session user})]
			condition:  [:listElement | (listElement students includes: self session user) ~= true]
			text: 'whlen';
			addCommand: [:listElement | listElement removeStudent: self session user]
			condition:  [:listElement | (listElement students includes: self session user)]
			text: 'ndern';
			yourself).}! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:25'!
detailComponent
	^ DLUserTopicDetailComp! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 15:44'!
initializeReport
	super initializeReport.
	self magritteReport tableEmpty:  'Noch kein ', self listClass metaName, ' gewhlt.'! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:24'!
listClass
	^ DLTopic! !

!DLUserTopicListComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:03'!
listObjects
	
	"|lectures topics|
	topics := OrderedCollection new.
	lectures  := (SqsSearch for: DLLecture) select: [:aLecture  | aLecture students includes: self user].
	topics    := (SqsSearch for: DLTopic) select: [:aTopic | aTopic lecture = lectures].
	  
	^topics"
	
	| lectures topics |
	lectures := (SqsSearch for: DLLecture) findAll select: [:aLecture | (aLecture topicPhaseActive = true) & (aLecture students includes: self session user)].
	lectures := lectures select: [:aLecture |
			"Can we do this nicer?"
			| truth |
			truth := false.
			(self session user topicForLecture: aLecture) ifNil: [truth := true].
			truth
		].
	topics := (SqsSearch for: DLTopic) findAll select: [:aTopic | lectures includes: aTopic lecture].
	^ topics.! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user

	^ user! !

!DLUserTopicListComp methodsFor: 'accessing' stamp: 'caro 7/3/2009 22:04'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLPermissionDeniedComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:02'!
permissionCheck
	"Always allow anyone to see permission denied"
	^ true! !

!DLPermissionDeniedComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:24'!
renderContent: html
	html heading: 'Permission denied';
		  paragraph: 'You have insufficient rights to open this page.'! !

DLComponent subclass: #DLUserConfirmJoinComp
	instanceVariableNames: 'group user'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmJoinComp class methodsFor: 'as yet unclassified' stamp: 'caro 7/12/2009 20:01'!
for: aUser with: aGroup
	^ self new
		user: aUser;
		group: aGroup;
		yourself.! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group

	^ group! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 14:32'!
group: anObject

	group := anObject.! !

!DLUserConfirmJoinComp methodsFor: 'as yet unclassified' stamp: 'caro 6/19/2009 21:32'!
isNotInGroup
	|answer|
	answer := (SqsSearch for: DLGroup) select: [:aGroup | (aGroup students) includes: (self session user)].
	"es entsteht immer eine leere orderedCollection"
	answer ifEmpty: [^true].
	^false! !

!DLUserConfirmJoinComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/20/2009 22:14'!
permissionCheck
	^ self session isLoggedIn.! !

!DLUserConfirmJoinComp methodsFor: 'as yet unclassified' stamp: 'caro 7/12/2009 21:55'!
renderContent: html
	(self user groupForLecture: self group lecture) isNil
	ifTrue:[
			html text: 'Die Gruppe "', (self group groupName) asString, '" wirklich whlen?'; break.
			html anchor 
				callback: [self answer: true];
				text: 'Ja'.
			html break.
			html anchor
				callback: [self answer: false];
				text: 'Nein'.
		]
	ifFalse: [
		html div with: [
			html text:'Sie sind fr die Lehrveranstaltung ',self group lecture canonicalName,' schon in einer Gruppe eingetragen!!'.
			html break.
			html anchor
				callback: [self call: (DLLeaveTask for: self group)];
				text: 'Meine Gruppe "',self group groupName ,'" verlassen'
			].
		]	

! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user

	^ user! !

!DLUserConfirmJoinComp methodsFor: 'accessing' stamp: 'caro 7/12/2009 19:17'!
user: anObject

	user := anObject.! !

DLComponent subclass: #DLUserConfirmLeaveComp
	instanceVariableNames: 'group'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLUserConfirmLeaveComp class methodsFor: 'as yet unclassified' stamp: 'caro 6/19/2009 20:08'!
for: aGroup
	^ self new
		group: aGroup;
		yourself.! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group

	^ group! !

!DLUserConfirmLeaveComp methodsFor: 'accessing' stamp: 'caro 6/19/2009 20:07'!
group: anObject

	group := anObject.! !

!DLUserConfirmLeaveComp methodsFor: 'as yet unclassified' stamp: 'caro 6/19/2009 20:17'!
permissionCheck
	^ true.! !

!DLUserConfirmLeaveComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/20/2009 23:11'!
renderContent: html
	html text: 'Mchten sie die Gruppe "', self group groupName, '" wirklich verlassen?'; break.
	html anchor 
		callback: [self answer: true];
		text: 'Ja'.
	html break.
	html anchor
		callback: [self answer: false];
		text: 'Nein'.! !

WAComponent subclass: #DLMenuComp
	instanceVariableNames: 'entries content'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:18'!
addEntries
	"If an inheriting method has defined this method, we use it to automagically insert entries"
	self entries
		add: 'Andere Aktionen' -> { 
			'Ausloggen' -> [self session logout.]}.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/26/2009 17:12'!
addEntry: aString withAction: aBlock
	
	^ self entries add: aString -> aBlock! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 6/13/2009 19:00'!
entries

	^ entries ifNil: [self entries: OrderedCollection new. self addEntries. ^ entries]! !

!DLMenuComp methodsFor: 'accessing' stamp: 'sebh 5/26/2009 17:08'!
entries: anObject

	entries := anObject.! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 14:01'!
renderContentOn: html
	self entries
		do: [:entry | self renderEntry: entry on: html. ]! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 5/27/2009 15:50'!
renderEntry: anEntry on: html
	self renderEntry: anEntry on: html level: 2 ! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 14:13'!
renderEntry: anEntry on: html level: aLevel
	anEntry value isCollection
	ifTrue: [ 
		"html heading: anEntry key level: aLevel."
		html unorderedList class: anEntry key; with: [
			anEntry value do: [:entry | self renderEntry: entry on: html level: aLevel+1].
		]
	]
	ifFalse: [
		html listItem: [
			html anchor
				callback: anEntry value;
				with: anEntry key.
			]
		].! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 13:42'!
showComponent: aComponent
	self session announcer announce: ((self signal) forComponent: aComponent)! !

!DLMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 17:55'!
signal
	^ DLViewCompReplacement! !

DLMenuComp subclass: #DLUserMenuComp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

DLUserMenuComp subclass: #DLAdminMenuComp
	instanceVariableNames: 'lectureListComp formComponent'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLAdminMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/13/2009 23:19'!
addEntries
	(self session user isAdmin) ifTrue:
	[self entries
		add: 'Admin' -> {
			'Deadlines' 
				-> [self showComponent: (DLAdminDeadLineListComp new)].
			'Themen' 
				-> [self showComponent: (DLAdminTopicListComp for: DLTopic)].
			'Gruppen'
				-> [self showComponent: (DLAdminListComp for: DLGroup)].
			'Lehrveranstaltungen'
				-> [self showComponent: (DLAdminLectureListComp new)].
			'Benutzer' 			   
				-> [self showComponent: (DLAdminUserListComp new)].
			'Dateitypen' 		  
				-> [self showComponent: (DLAdminListComp for: DLFileType)].
		}].	
	super addEntries.
		! !

!DLUserMenuComp methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 23:48'!
addEntries
	self entries
		add: 'Benutzer' -> {
			'Aktuelle Lehrveranstaltungen'
				-> [self showComponent: (DLUserLectureListComp new)].
			'Aktuelle Themen'
				-> [self showComponent: (DLUserTopicListComp new)].
			'Meine Lehrveranstaltungen'
				-> [self showComponent: (DLUserLectureListComp with: {#students->self session user})].
			'Meine Gruppen'
				-> [self showComponent: (DLUserGroupListComp with: {#students->self session user})].
			'Meine Deadlines'
				-> [self showComponent: (DLUserDeadlineListComp for: self session user)].
			'Mein Profil'
				-> [self showComponent: (DLUserProfileDetailComp for: self session user)].
		}.
	super addEntries! !

WAComponent subclass: #DLMenuEntry
	instanceVariableNames: 'content active block'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
active

	^ active! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
active: anObject

	active := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block

	^ block! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
block: anObject

	block := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
content

	^ content! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
content: anObject

	content := anObject.! !

!DLMenuEntry methodsFor: 'accessing' stamp: 'sebh 6/13/2009 13:41'!
initialize
	super initialize.
	self active: False.! !

WAComponent subclass: #DLRootComponent
	instanceVariableNames: 'menuComp viewComp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-frontend'!

!DLRootComponent class methodsFor: 'as yet unclassified' stamp: 'sebh 6/10/2009 12:17'!
canBeRoot
	^ true.! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 12:00'!
children
	^ Array with: self viewComp with: self menuComp! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 18:56'!
initialize
	super initialize.
	self menuComp: DLAdminMenuComp new.
	self session announcer on: DLViewCompReplacement do: [:announcement | self viewComp: announcement component ].
	self session announcer on: DLLogoutAnnouncement  do: [:announcement | self answer: true. ]! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/13/2009 18:55'!
menuComp

	^ menuComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
menuComp: anObject

	menuComp := anObject.! !

!DLRootComponent methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 16:32'!
renderContentOn: html
	html div class:'header';  with: [
		html image url: 'http://upload.devdojo.de/deli.png'.
		html div class:'menu';	  with: self menuComp.
		].
	html div class:'content'; with: self viewComp.
	html div class:'footer';  with: [html text: 'Deli. A product.']! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp

	^ viewComp! !

!DLRootComponent methodsFor: 'accessing' stamp: 'sebh 6/3/2009 12:10'!
viewComp: anObject

	viewComp := anObject.! !

Object subclass: #DLModel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

DLModel subclass: #DLDeadline
	instanceVariableNames: 'deadlineName deadlineDescription lecture date time requirements'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:01'!
descriptionDeadlineDescription
	^ (MAMemoDescription auto:'deadlineDescription' label: 'Beschreibung' priority: 30) 
		beRequired;
		yourself.! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'Marik 7/9/2009 13:24'!
descriptionDeadlineName
	^ (MAStringDescription auto: 'deadlineName' label: 'Titel' priority: 20)
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'as yet unclassified' stamp: 'Marik 7/9/2009 14:17'!
descriptionTime
	^ (MATimeDescription auto: 'time' label: 'Uhrzeit' priority: 50)
			default: '23:59:59';
			beRequired;
			yourself.
! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:33'!
metaName
	^ 'Abgabetermin'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:01'!
metaNamePlural
	^ 'Abgabetermine'! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDate
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'date';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'date';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineDescription';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadlineName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'deadline_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadlineName';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirements
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_deadlines_requirements';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_deadline_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_deadlines';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_deadline_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'requirements_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_requirements';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'requirements_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLRequirement;
		 linkedVariable: 'requirements';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLDeadline class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTime
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'time';
		 sqlType: #time;
		 objectClass: #Time;
		 tableName: 'dl_deadlines';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'time';
		 yourself! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/14/2009 12:10'!
additionalDescriptions
	^ {self descriptionGroup.self descriptionLecture.self descriptionRequirements.self descriptionDate}! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:53'!
collectDependentObjects
	| dependentDeliveries dependentRequirement |
	dependentDeliveries := (SqsSearch for: DLDelivery)    select: [:aDelivery   | aDelivery    deadline = self].
	dependentRequirement:= self requirements.
	^ dependentDeliveries! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/1/2009 11:22'!
countDeliveriesComplete

	| completedDeliveries |
	completedDeliveries := 0.
	self deliveries do: [:aDelivery | (aDelivery isComplete) ifTrue: [completedDeliveries := completedDeliveries + 1]].
	^ completedDeliveries.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date

	^ date! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
date: anObject

	date := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/1/2009 09:11'!
dateAndTime

	^ DateAndTime date: self date time: self time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription

	^ deadlineDescription! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 20:57'!
deadlineDescription: anObject

	deadlineDescription := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName

	^ deadlineName! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:55'!
deadlineName: anObject

	deadlineName := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/1/2009 11:16'!
deliveries

	^(SqsSearch for: DLDelivery) select: [:aDelivery | aDelivery deadline = self].! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/14/2009 12:10'!
descriptionDate
	^ (MADateDescription auto: 'date' label: 'Datum' priority: 40)
			default: (Date today addMonths: 1);
			beRequired;
			yourself.
! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/2/2009 22:47'!
descriptionGroup
	^ (MASingleOptionDescription auto: 'group' label: 'Gruppe' priority: 25)
			optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | aGroup lecture = self lecture]);
			comment: 'Gruppenspezifischen Termin festlegen durch Auswahl.'
			yourself.! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:13'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
			beRequired;
			yourself.
! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:22'!
descriptionList
 ^ super description select: [:each | #(deadlineDescription deadlineName date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:14'!
descriptionRequirements
	^ (MAToManyRelationDescription auto: 'requirements' label:'Abgaben' priority:60)
			classes: (Array with: DLRequirement);
			default: Array new;
			yourself.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/2/2009 22:45'!
descriptionUpdate
 ^ super description select: [:each | #(lecture group deadlineName deadlineDescription date time requirements) includes: each accessor selector]! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group

	^ group! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:54'!
group: anObject

	group := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/8/2009 23:14'!
initialize
	super initialize.
	self requirements: OrderedCollection new.! !

!DLDeadline methodsFor: 'as yet unclassified' stamp: 'Marik 7/9/2009 13:43'!
isCritical
	
	| timeDifference panicTime |
	panicTime := Duration days: 1.
	timeDifference := self dateAndTime - (DateAndTime date: (Date today) time: (Time now)).
		((Duration new < timeDifference) & (timeDifference < panicTime))
		ifTrue: [^ true].
	^false
	! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:35'!
isExpired

	^ self dateAndTime < (DateAndTime date: (Date today) time: (Time now)).! !

!DLDeadline methodsFor: 'as yet unclassified' stamp: 'Marik 7/9/2009 13:44'!
isNotCritical

	^ ((self isExpired not) & (self isCritical not))! !

!DLDeadline methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:35'!
isNotExpired

	^ self isExpired not.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture

	^ lecture! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/3/2009 22:03'!
lecture: anObject

	lecture := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:56'!
requirements

	^ requirements! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/9/2009 19:23'!
requirements: anObject
	"Prevent the list from being replaced so squeaksave can always determine changed objects"
   | removedObjects addedObjects |
	(anObject class includesBehavior: SqsCollectionProxy) 
	ifTrue: [ "This message comes from SqueakSave, we like that!!" ^ requirements := anObject.].
	requirements ifNil: [requirements := OrderedCollection new].
	removedObjects := requirements difference: anObject.
	addedObjects   := anObject difference: requirements.
	removedObjects do: [:obj | requirements remove: obj].
	addedObjects   do: [:obj | requirements add: obj].
	"Save all objects so that they will have oids for the change recognition".
	requirements   do: [:obj | obj save.].
! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time

	^ time! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:32'!
time: anObject

	time := anObject.! !

!DLDeadline methodsFor: 'accessing' stamp: 'sebh 7/1/2009 01:09'!
trackChangeVariables
	^ {'deadlineDescription'. 'requirements'. 'date'. 'time'.}! !

DLModel subclass: #DLDeliverable
	instanceVariableNames: 'delivery deliverableRequirement filePath fileSize'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 23:10'!
descriptionDeliverableRequirement
	^ (MAStringDescription auto: 'deliverableRequirement' label: 'Requirement' priority: 20)
			beReadonly;
			yourself.
! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'Marik 6/10/2009 14:06'!
descriptionDelivery
	^ (MAStringDescription auto: 'delivery' label: 'Delivery' priority: 10)
			beHidden;
			beRequired;
			yourself.
! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'Marik 6/24/2009 15:22'!
metaName
	^ 'Abgabedatei'! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabedateien'! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:16'!
rightCreate: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:16'!
rightDelete: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'as yet unclassified' stamp: 'sebh 7/14/2009 00:17'!
rightUpdate: aUser
	^ false.! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeliverableRequirement
	^ SqsColumn new associatedClass: #DLRequirement;
		 manuallyMaintained: false;
		 columnName: 'deliverable_requirement_id';
		 sqlType: #integer;
		 objectClass: #DLRequirement;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deliverableRequirement';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDelivery
	^ SqsColumn new associatedClass: #DLDelivery;
		 manuallyMaintained: false;
		 columnName: 'delivery_id';
		 sqlType: #integer;
		 objectClass: #DLDelivery;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'delivery';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFilePath
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_path';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filePath';
		 yourself! !

!DLDeliverable class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'file_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_deliverables';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'fileSize';
		 yourself! !

!DLDeliverable methodsFor: 'accessing' stamp: 'Marik 7/1/2009 10:33'!
additionalDescriptions
	^ {self descriptionFileModel}.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'caro 7/9/2009 14:38'!
canonicalName
	^ self delivery canonicalName, ' - ', self filePath! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement

	^ deliverableRequirement! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:48'!
deliverableRequirement: anObject

	deliverableRequirement := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery

	^ delivery! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/18/2009 15:58'!
delivery: anObject

	delivery := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 7/14/2009 00:14'!
descriptionFileModel
	| extensionsText extensions |
	self deliverableRequirement ifNotNilDo: [:aRequirement |
		extensions := aRequirement filetype extensions.
		extensionsText := aRequirement filetype extensionsText.
		] ifNil:	[
		extensions := {}.
		extensionsText := ''.
		].
	^ (MAFileDescription auto: 'fileModel' label: 'Datei' priority: 80)
		beRequired;
		componentClass: DLMADeliverableFileUploadComponent;
		kind: DLMAExternalFileModel;
	   addCondition: [:anUploadedFile | extensions includes: '.' , anUploadedFile extension]
		labelled: 'Dateityp muss einer der folgenden Endungen entsprechen: ' , extensionsText;
		addCondition: [:anUploadedFile | self delivery ifNotNilDo: [:aDelivery | aDelivery deadline isNotExpired]]
		labelled: 'Die Abgabefrist ist leider bereits ausgelaufen.';
		comment: 'Nur Dateien mit Endung(en) ', extensionsText ,' erlaubt.';
		yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/17/2009 12:12'!
fileModel

	| separatedPath filename delimiter path |
	self filePath isEmpty ifTrue: [^ nil].
	delimiter := (FileDirectory default pathNameDelimiter).
	separatedPath := self filePath tokensBasedOn: delimiter.
	path := separatedPath allButLast.
	filename := separatedPath last.
	^ DLMAExternalFileModel new 
				location: path;
				filename: filename;
				filesize: self fileSize;
				yourself.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileModel: aFileModel
	| delimiter |
	delimiter := (FileDirectory default pathNameDelimiter) asString.
	self filePath: (aFileModel location join: delimiter),delimiter, aFileModel filename.
	self fileSize: aFileModel filesize.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:21'!
filePath

	^ filePath! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 00:24'!
filePath: anObject

	filePath := anObject.! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:36'!
fileSize

	^ fileSize! !

!DLDeliverable methodsFor: 'accessing' stamp: 'sebh 6/14/2009 01:37'!
fileSize: anObject

	fileSize := anObject.! !

!DLDeliverable methodsFor: 'accessing-generated' stamp: 'Marik 6/10/2009 17:22'!
initialize 

	super initialize.
	self filePath: ''.! !

DLModel subclass: #DLDelivery
	instanceVariableNames: 'group deadline'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 6/18/2009 15:52'!
getOrCreateFrom: anArray
 	| result |
	result := super getOrCreateFrom: anArray.
	result deadline requirements do: [:aRequirement |
		DLDeliverable getOrCreateFrom: {#delivery->result. #deliverableRequirement->aRequirement}.
		].
	^ result.! !

!DLDelivery class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 22:31'!
metaName
	^ 'Abgabe'! !

!DLDelivery class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgaben'! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:21'!
rightCreate: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightDelete: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:22'!
rightUpdate: aUser
	^ false! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDeadline
	^ SqsColumn new associatedClass: #DLDeadline;
		 manuallyMaintained: false;
		 columnName: 'deadline_id';
		 sqlType: #integer;
		 objectClass: #DLDeadline;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'deadline';
		 yourself! !

!DLDelivery class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroup
	^ SqsColumn new associatedClass: #DLGroup;
		 manuallyMaintained: false;
		 columnName: 'group_id';
		 sqlType: #integer;
		 objectClass: #DLGroup;
		 tableName: 'dl_deliverys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'group';
		 yourself! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:16'!
additionalDescriptions
	^ {self descriptionGroup.self descriptionDeadline}! !

!DLDelivery methodsFor: 'as yet unclassified' stamp: 'Marik 7/1/2009 15:32'!
canonicalName
	^ self deadline canonicalName, ' ', self group canonicalName! !

!DLDelivery methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:48'!
collectDependentObjects
	| dependentDeliverables |
	dependentDeliverables := (SqsSearch for: DLDeliverable) select: [:aDeliverable | aDeliverable delivery = self].
	^ dependentDeliverables! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline

	^ deadline! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
deadline: anObject

	deadline := anObject.! !

!DLDelivery methodsFor: 'accessing' stamp: 'sebh 6/18/2009 22:57'!
deliverables
	^ (SqsSearch for: DLDeliverable) select: [:aDeliverable | aDeliverable delivery = self]! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:15'!
descriptionDeadline
	^ (MASingleOptionDescription auto: 'deadline' label: 'Deadline' priority: 10)
			optionsAndLabels: (DLDeadline getKeyValueSelect: [:aDeadline | ]);
			beRequired;
			yourself.! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:16'!
descriptionGroup
	^ (MASingleOptionDescription auto: 'group' label: 'Gruppe' priority: 20)
			optionsAndLabels: (DLGroup getKeyValueSelect: [:aGroup | ]);
			beRequired;
			yourself.! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group

	^ group! !

!DLDelivery methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:52'!
group: anObject

	group := anObject.! !

!DLDelivery methodsFor: 'accessing' stamp: 'Marik 7/1/2009 11:10'!
isComplete

	| complete | 
	complete := true.
	self deliverables do: [:aDeliv | (aDeliv filePath = '') ifTrue: [complete := false]].
	^ complete! !

DLModel subclass: #DLFileType
	instanceVariableNames: 'filetypeName extensions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:45'!
createFileType: aTypeName extensions: someExtensions
	^ self new
		filetypeName: aTypeName;
		extensions: someExtensions;
		save;
		yourself.! !

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:46'!
descriptionExtensions
	^ (MAMemoDescription auto: 'extensionsText' label: 'Dateiendungen' priority: 20)
			comment: 'Eine komma-separierte Liste der Dateiendungen z.B. ".pdf,.ppt"';
			yourself.
! !

!DLFileType class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:47'!
descriptionFiletypeName
	^ (MAStringDescription auto: 'filetypeName' label: 'Name' priority: 10)
			beRequired;
			yourself.
! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaName
	^ 'Abgabetyp'! !

!DLFileType class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Abgabetypen'! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'extensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFileExtensions
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_file_types_file_extensions';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_file_type_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_file_types';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_file_type_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'value';
			 instVarAt: 4 put: #string;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: nil;
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: true;
		 indexType: #integer;
		 referencedClass: #ByteString;
		 linkedVariable: 'fileExtensions';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'filetype_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetypeName';
		 yourself! !

!DLFileType class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTypeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'type_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_file_types';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'typeName';
		 yourself! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'Marik 7/12/2009 14:43'!
canonicalName
	^ self filetypeName,' <',self extensionsText,'>'! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions

	^ extensions! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:44'!
extensions: anObject

	extensions := anObject.! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:44'!
extensionsText
	^ self extensions join: ', '! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:44'!
extensionsText: aText
	"Converts the comma-separated string into an OrderedCollection and checks whether the extension starts with a dot."
	^ self extensions: (OrderedCollection newFrom: (((aText reject: [:char | char = $ .]) tokensBasedOn: $,) select: [:each | each first = $.]))! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName

	^ filetypeName! !

!DLFileType methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:43'!
filetypeName: anObject

	filetypeName := anObject.! !

!DLFileType methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:45'!
initialize

	super initialize.
	self extensions: OrderedCollection new.! !

DLModel subclass: #DLGroup
	instanceVariableNames: 'groupName groupDescription lecture students'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:21'!
descriptionGroupDescription
	^ (MAStringDescription auto: 'groupDescription' label: 'Beschreibung' priority: 10)
			beRequired;
			yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'cr 6/6/2009 17:20'!
descriptionGroupName
	^ (MAStringDescription auto: 'groupName' label: 'Gruppenname' priority: 10)
			beRequired;
			yourself.! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'Marik 7/13/2009 16:06'!
descriptionMail
	^ (DLMAMailDescription auto: 'mail' label: 'E-Mail' priority: 140)
			reportColumnClass: DLMALinkColumnMail;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:34'!
metaName
	^ 'Gruppe'! !

!DLGroup class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:02'!
metaNamePlural
	^ 'Gruppen'! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'description';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupDescription';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupName';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_groups';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUsers
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_groups_users';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_group_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_groups';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_group_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'users_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'users_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'users';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 6/20/2009 22:11'!
addStudent: aUser
	(self students includes: aUser)
	ifFalse: [
		self students add: aUser.
		self save.
	]! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:17'!
additionalDescriptions
	^ {self descriptionStudents.self descriptionLecture}! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 6/9/2009 17:48'!
canonicalName
	^ self groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:58'!
collectDependentObjects
	| dependentDeadlines dependentDeliveries |
	"dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline group = self]."
	dependentDeliveries:= (SqsSearch for: DLDelivery) select: [:aDelivery | aDelivery group = self].
	^ "dependentDeadlines," dependentDeliveries.! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/13/2009 15:13'!
description
 ^ super description select: [:each | #(groupName students lecture mail) includes: each accessor selector]! !

!DLGroup methodsFor: 'accessing' stamp: 'MG 7/13/2009 17:12'!
descriptionCreate
 ^ super description select: [:each | #(groupName students lecture) includes: each accessor selector]! !

!DLGroup methodsFor: 'accessing' stamp: 'MG 7/13/2009 17:14'!
descriptionDetail
 ^ self descriptionCreate! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:17'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture |]);
			beRequired;
			yourself.! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/13/2009 15:15'!
descriptionList
 ^ super description select: [:each | #(groupName students lecture mail) includes: each accessor selector]! !

!DLGroup methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:17'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 60)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLGroup methodsFor: 'accessing' stamp: 'MG 7/13/2009 17:13'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription

	^ groupDescription! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:27'!
groupDescription: anObject

	groupDescription := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName

	^ groupName! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/20/2009 20:54'!
groupName: anObject

	groupName := anObject.! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:32'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture

	^ lecture! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 5/26/2009 11:19'!
lecture: anObject

	lecture := anObject.! !

!DLGroup methodsFor: 'as yet unclassified' stamp: 'Marik 7/13/2009 15:57'!
mail

	| linkCollection |
	linkCollection := OrderedCollection new.
	self students do:[:each| linkCollection add: (each email)].
	^ 'mailto:',(linkCollection join: ',').! !

!DLGroup methodsFor: 'accessing' stamp: 'sebh 6/20/2009 22:11'!
removeStudent: aUser
	(self students includes: aUser)
	ifTrue: [
		self students remove: aUser.
		self save.
	]! !

!DLGroup methodsFor: 'accessing-generated' stamp: 'cr 6/6/2009 17:23'!
students
	^ students! !

!DLGroup methodsFor: 'accessing' stamp: 'cr 6/6/2009 17:31'!
students: anObject

	students := anObject.! !

DLModel subclass: #DLLecture
	instanceVariableNames: 'lectureName lectureDescription lectureHomepage mailingList semester teacher assistants studentAssistants students visible groupSize groupingPhase topicPhase'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:42'!
createLectureName: aLectureName semester: aSemester description: aDescription
	^ self new
		lectureName: aLectureName;
		semester: aSemester;
		description: aDescription;
		save;
		yourself.! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:52'!
descriptionGroupSize
	^ (MANumberDescription auto: 'groupSize' label: 'Gruppengre' priority: 70)
			comment: 'Maximale Gruppengre';
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 23:32'!
descriptionLectureDescription
	^ (MAMemoDescription auto: 'lectureDescription' label: 'Beschreibung' priority: 20)
			reportColumnClass: DLMATruncatedStringColumn;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 7/14/2009 11:30'!
descriptionLectureHomepage
	^ (MAStringDescription auto: 'lectureHomepage' label: 'Webseite' priority: 25)
			reportColumnClass: DLMALinkColumn;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'cr 5/31/2009 16:01'!
descriptionLectureName
	^ (MAStringDescription auto: 'lectureName' label: 'Lehrveranstaltung' priority: 10)
			beRequired;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 7/13/2009 16:09'!
descriptionMail
	^ (DLMAMailDescription auto: 'mail' label: 'E-Mail' priority: 140)
			reportColumnClass: DLMALinkColumnMail;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 7/14/2009 11:30'!
descriptionMailingList
	^ (MAStringDescription auto: 'mailingList' label: 'E-Mail Verteiler' priority: 27)
			reportColumnClass: DLMALinkColumn;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 6/9/2009 13:55'!
descriptionVisible
	^ (MABooleanDescription auto: 'visible' label: 'Sichtbar' priority: 70)
			default: true;
			trueString: 'Sichtbar';
			falseString:'Nicht sichtbar';
			yourself.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'Marik 5/27/2009 15:47'!
getOrCreateUserName: aLectureName semester: aSemester description: aDescription

	| lecture |
	lecture := (SqsSearch for: self) detect: [:aLecture | 
		(aLecture lectureName = aLectureName) & (aLecture semester = aSemester)]
	                                 ifNone: [nil].
	lecture ifNotNil: [ ^ lecture ].
	^ self createLectureName: aLectureName semester: aSemester description: aDescription.
! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Lehrveranstaltung'! !

!DLLecture class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:03'!
metaNamePlural
	^ 'Lehrveranstaltungen'! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'assistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupSize
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'group_size';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupSize';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrGroupingPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'grouping_phase';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'groupingPhase';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_description';
		 sqlType: #text;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureDescription';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureHomepage
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_homepage';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureHomepage';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLectureName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'lecture_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lectureName';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mail';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mail';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMailingList
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mailing_list';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mailingList';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemester
	^ SqsColumn new associatedClass: #DLSemester;
		 manuallyMaintained: false;
		 columnName: 'semester_id';
		 sqlType: #integer;
		 objectClass: #DLSemester;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semester';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudentAssistants
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_student_assistants';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'student_assistants_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'student_assistants_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'studentAssistants';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_lectures_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_lecture_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_lectures';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_lecture_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTeacher
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'teacher_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'teacher';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_phase';
		 sqlType: #date;
		 objectClass: #Date;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicPhase';
		 yourself! !

!DLLecture class methodsFor: 'persistence-description' stamp: ''!
sqsDescrVisible
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'visible';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_lectures';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'visible';
		 yourself! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/20/2009 23:04'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/14/2009 12:12'!
additionalDescriptions
	^ {self descriptionAssistants.self descriptionSemester.self descriptionStudents.
	self descriptionStudentAssistants.self descriptionTeacher.self descriptionGroupingPhase.self descriptionTopicPhase}! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants

	^ assistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
assistants: anObject

	assistants := anObject.! !

!DLLecture methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 19:13'!
canonicalName
	^ self lectureName, ' ', self semester canonicalName! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:54'!
collectDependentObjects
	| dependentDeadlines dependentGroups dependentTopics|
	dependentDeadlines := (SqsSearch for: DLDeadline) select: [:aDeadline | aDeadline lecture = self].
	dependentGroups 	 := (SqsSearch for: DLGroup)    select: [:aGroup 	 | aGroup 	 lecture = self].
	dependentTopics 	 := (SqsSearch for: DLTopic)    select: [:aTopic 	 | aTopic 	 lecture = self].
	^ dependentDeadlines, dependentGroups, dependentTopics.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:34'!
descriptionAssistants
	^ (MAMultipleOptionDescription auto: 'assistants' label: 'Assistent' priority: 35)
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isAssistant]);
		yourself.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:24'!
descriptionCreate
 ^ self description select: [:each | #(lectureName semester lectureDescription lectureHomepage mailingList teacher assistants studentAssistants visible groupingPhase topicPhase) includes: each accessor selector]! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/13/2009 17:11'!
descriptionDetail
 ^ self descriptionCreate! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/14/2009 12:12'!
descriptionGroupingPhase
	^ (MADateDescription auto: 'groupingPhase' label: 'Gruppenwahl bis' priority: 80)
			default: (Date today addMonths: 1);
			beRequired;
			comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten neue Gruppen erstellen, beitreten oder verlassen.';
			yourself.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:16'!
descriptionList
 ^ self description select: [:each | #(lectureName lectureDescription lectureHomepage mail teacher semester) includes: each accessor selector]! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:20'!
descriptionSemester
	^ (MASingleOptionDescription auto: 'semester' label: 'Semester' priority: 50)
			optionsAndLabels: (DLSemester getKeyValueSelect: [:aSemester | aSemester year > 2008]);
			beRequired;
			reference: MAStringDescription new;
			yourself.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:20'!
descriptionStudentAssistants
	^ (MAMultipleOptionDescription auto: 'studentAssistants' label: 'Studentische Assistenten' priority: 40)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isStudentAssistant ]);
			yourself.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:20'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 60)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:34'!
descriptionTeacher
	^ (MASingleOptionDescription auto: 'teacher' label: 'Dozent' priority: 30)
		optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | aUser isTeacher]);
		beRequired;
		yourself.
! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/14/2009 12:11'!
descriptionTopicPhase
	^ (MADateDescription auto: 'topicPhase' label: 'Themenwahl bis' priority: 90)
			default: (Date today addMonths: 1);
			beRequired;
			comment: 'Ist dieses Datum noch nicht erreicht, knnen Studenten Themen whlen und auch abwhlen.';
			yourself.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:23'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize

	^ groupSize! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 5/31/2009 16:02'!
groupSize: anObject

	groupSize := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:37'!
groupingPhase

	^groupingPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/20/2009 22:26'!
groupingPhase: anObject

	groupingPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:47'!
groupingPhaseActive
"returns true if groupingPhase is active"
	^self groupingPhase < (DateAndTime date: (Date today) time: (Time now))! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 7/6/2009 21:09'!
initialize
	super initialize.
	self assistants: OrderedCollection new;
		  students: OrderedCollection new;
		  studentAssistants: OrderedCollection new.
	self visible: true.
	self groupingPhase: Date new.
	self topicPhase: Date new.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription

	^ lectureDescription! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/27/2009 16:23'!
lectureDescription: anObject

	lectureDescription := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage

	^ lectureHomepage! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/9/2009 13:59'!
lectureHomepage: anObject

	lectureHomepage := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName

	^ lectureName! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
lectureName: anObject

	lectureName := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'MG 7/13/2009 16:55'!
mail

	| receivers |	
	self mailingList isNil
		ifTrue: [| linkCollection |
			linkCollection := OrderedCollection new.
			self students do:[:each| linkCollection add: (each email)].
			receivers := (linkCollection join: ',')]
		ifFalse: [receivers := self mailingList].
	^ 'mailto:?bcc=', receivers! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList

	^ mailingList! !

!DLLecture methodsFor: 'accessing' stamp: 'Marik 7/13/2009 16:13'!
mailingList: anObject

	mailingList := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/20/2009 23:08'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.
! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester

	^ semester! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 5/20/2009 16:23'!
semester: anObject

	semester := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants

	^ studentAssistants! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/9/2009 14:00'!
studentAssistants: anObject

	studentAssistants := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students

	^ students! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
students: anObject

	students := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher

	^ teacher! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/3/2009 18:08'!
teacher: anObject

	teacher := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:47'!
topicPhase

	^ topicPhase! !

!DLLecture methodsFor: 'accessing' stamp: 'caro 6/28/2009 16:39'!
topicPhase: anObject

	topicPhase := anObject.! !

!DLLecture methodsFor: 'accessing' stamp: 'cr 7/8/2009 15:47'!
topicPhaseActive
"returns true if topicPhase is active"
	^ self topicPhase < (DateAndTime date: (Date today) time: (Time now))! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible

	^ visible! !

!DLLecture methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:18'!
visible: anObject

	visible := anObject.! !

DLModel subclass: #DLLogEntry
	instanceVariableNames: 'klassName objectId message changes user created'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 02:14'!
descriptionChanges
	^ (MAStringDescription auto: 'changes' label: 'Vernderungen' priority: 10)
		reportColumnClass: DLMAChangesColumn;
		yourself.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:25'!
descriptionCreated
	^ (MATimeStampDescription auto: 'created' label: 'Erzeugt' priority: 10).
	! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:47'!
descriptionUser
	^ (MAToOneRelationDescription auto: 'user' label: 'Benutzer' priority: 20)
		classes: {DLUser};
		undefined: 'System';
		yourself.
	! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'Logbucheintrag'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:17'!
metaNamePlural
	^ 'Logbucheintrge'! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:15'!
rightCreate: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDelete: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:16'!
rightDetail: aUser
	^ false! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: 'sebh 6/30/2009 22:20'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrChanges
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_log_entrys_changes';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_log_entry_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_log_entrys';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_log_entry_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'changes_id';
			 sqlType: #integer;
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLLogEntryChange;
		 linkedVariable: 'changes';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrCreated
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'created';
		 sqlType: #dateAndTime;
		 objectClass: #DateAndTime;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'created';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlass
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klass';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlassName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klassName';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectId
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_id';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectId';
		 yourself! !

!DLLogEntry class methodsFor: 'persistence-description' stamp: ''!
sqsDescrUser
	^ SqsColumn new associatedClass: #DLUser;
		 manuallyMaintained: false;
		 columnName: 'user_id';
		 sqlType: #integer;
		 objectClass: #DLUser;
		 tableName: 'dl_log_entrys';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'user';
		 yourself! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes

	^ changes! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
changes: anObject

	changes := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created

	^ created! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:21'!
created: anObject

	created := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:27'!
initialize
	super initialize.
	self created: DateAndTime now.
	self changes: OrderedCollection new.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:49'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
message

	^ message! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
message: anObject

	message := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId

	^ objectId! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:13'!
objectId: anObject

	objectId := anObject.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:17'!
rightUpdate: aUser
	^ false.! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 7/1/2009 00:44'!
trackChangeVariables
	"DON'T even think about it"
	^ {}! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user

	^ user! !

!DLLogEntry methodsFor: 'accessing' stamp: 'sebh 6/30/2009 22:43'!
user: anObject

	user := anObject.! !

DLModel subclass: #DLLogEntryChange
	instanceVariableNames: 'attributeName activity attributeValue klassName objectId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaName
	^ 'nderung'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/12/2009 03:16'!
metaNamePlural
	^ 'nderungen'! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightCreate: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightDelete: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: 'sebh 7/14/2009 00:30'!
rightUpdate: aUser
	^ false! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrActivity
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'activity';
		 sqlType: #string;
		 objectClass: #ByteSymbol;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'activity';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAttributeName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'attribute_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'attributeName';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrAttributeValue
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'attribute_value';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'attributeValue';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlass
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klass';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrKlassName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'klass_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'klassName';
		 yourself! !

!DLLogEntryChange class methodsFor: 'persistence-description' stamp: ''!
sqsDescrObjectId
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'object_id';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_log_entry_changes';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'objectId';
		 yourself! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity

	^ activity! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 01:35'!
activity: anObject

	activity := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName

	^ attributeName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeName: anObject

	attributeName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue

	^ attributeValue! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 14:30'!
attributeValue: anObject

	attributeValue := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:49'!
klass
	^ Smalltalk classNamed: self klassName.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName

	^ klassName! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/12/2009 02:48'!
klassName: anObject

	klassName := anObject.! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:29'!
objectId

	^ objectId! !

!DLLogEntryChange methodsFor: 'accessing' stamp: 'sebh 7/11/2009 13:30'!
objectId: anObject

	objectId := anObject.! !

DLModel subclass: #DLMail
	instanceVariableNames: 'subject text sender receivers'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 01:03'!
descriptionReceivers
		^ (MAStringDescription auto: 'receivers' label: 'Empfnger' priority: 10)
			beRequired;
			yourself.
		
! !

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 01:03'!
descriptionSender
		^ (MAStringDescription auto: 'sender' label: 'Absender' priority: 20)
			beRequired;
			yourself.
		
! !

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 01:03'!
descriptionSubject
		^ (MAStringDescription auto: 'subject' label: 'Betreff' priority: 30)
			beRequired;
			yourself.
		
! !

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 01:03'!
descriptionText
		^ (MAMemoDescription auto: 'text' label: 'Nachricht' priority: 40)
			beRequired;
			yourself.
		
! !

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/11/2009 10:35'!
metaName
	^ 'Mail'! !

!DLMail class methodsFor: 'as yet unclassified' stamp: 'sebh 7/11/2009 10:35'!
metaNamePlural
	^ 'Mails'! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:32'!
receivers

	^ receivers join: ','.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:34'!
receivers: someReceivers
	
	receivers := OrderedCollection newFrom: (someReceivers tokensBasedOn: $,).! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:40'!
receiversAsCollection
	
	^ receivers! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:36'!
receiversAsCollection: someReceivers
	
	receivers :=  someReceivers.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 15:39'!
sendMail

 | username password client |

	username := 'squeaky'.
	password := 'jflymcv98yM'.

	client := SMTPClient openOnHostNamed: 'darwin.yetisoft.net' port: 4400.
	client 	user: username;
			password: password;
			login;
			initiateSession.
	(self receiversAsCollection) do: [:anEmailAdress |  
	client 	mailFrom: self sender;
 			recipient: anEmailAdress;
 			data:	'Subject: ', self subject,' 
From: ', self sender,'
To: ', self receivers ,'
', self text].
	client quit.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
sender

	^ sender! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
sender: anObject

	sender := anObject.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject

	^ subject! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:18'!
subject: anObject

	subject := anObject.! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text

	^ text! !

!DLMail methodsFor: 'accessing' stamp: 'Marik 6/29/2009 14:19'!
text: anObject

	text := anObject.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 20:55'!
createFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	^ (self newFrom: anArray) save.
	! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:22'!
descriptionContainer
	^ super descriptionContainer
		componentRenderer: DLCssRenderer;
		yourself! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 14:29'!
getFrom: anAttributeArray 
	| keys values objects |
	keys := anAttributeArray collect: [ :anAttribute | anAttribute key ].
	values := anAttributeArray collect: [ :anAttribute | anAttribute value ].
	"We only contain objects that defined all their values"
	(values includes: nil) ifTrue: 
		[ DLNilValueException new
			messageText: 'A given value was nil';
			signal ].
	objects := (SqsSearch for: self) 
		searchBy: keys
		withValues: values
		limit: 2.
	objects isEmptyOrNil ifTrue: [
		DLNoResultException new
			messageText: 'No object was returned';
			signal.
		].
	objects size > 1 ifTrue: [ 
		DLMultipleResultsException new
			messageText: 'More than one element with similar default fields';
			signal.
		].
	"If there is really only one object, return it!!"
	^ objects first.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'Marik 6/9/2009 17:49'!
getKeyValueSelect: aBlock
	| objects kv |
	objects := (SqsSearch for: self) select: aBlock.
	kv := OrderedCollection new.
	objects do: [:object | kv add: (object -> object canonicalName)].
	^ kv
! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 14:28'!
getOrCreateFrom: anAttributeArray 
	"Get an object from a given attribute array, create one if it doesn't exist yet.'"
	| object |
	[object := self getFrom: anAttributeArray.]
 	on: DLNoResultException 
 	do: [:exc | ^ self createFrom: anAttributeArray].
	object ifNil: [^ self createFrom: anAttributeArray].
	^ object.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:27'!
metaName
	^ ''! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 7/9/2009 15:34'!
metaNamePlural
	^ ''! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 21:09'!
newFrom: anArray
	"Create an object with the values given in anArray and use the standard getters/setters so nondefault get/set behaviour works"
	| newobject |
	newobject := self new.
	anArray do: [:element | newobject perform: ((element key, ':') asSymbol) with: element value ].
	^ newobject! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:08'!
rightCreate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:09'!
rightDelete: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 19:28'!
rightDetail: aUser
	^ aUser notNil.! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:09'!
rightUpdate: aUser
	^ aUser isAdmin! !

!DLModel class methodsFor: 'as yet unclassified' stamp: 'sebh 5/28/2009 10:24'!
sqsAbstractBaseClass! !

!DLModel methodsFor: 'comparing' stamp: 'sebh 6/18/2009 22:20'!
= anotherObject
	"To circumvent crazy identity issues"
	^ (self class = anotherObject class) & (self oid = anotherObject oid).! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/26/2009 23:00'!
additionalDescriptions
	^ {}.! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/30/2009 12:05'!
canonicalName
	^ nil! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 7/12/2009 03:04'!
changesForField: aFieldName 
	"This method is overly complex and should be broken up into several parts.
	There might be a lot of ways to improve this method, especially with deeper insight into
	SqueakSave. Since we currently lag the time to dive deeper into SQS, further refactoring
	of this method should be deferrred.
	!!ObjectId will be added to all DLLogEntryChange objects after saving.
	"
	| field changes collectionChanges fieldDescription |
	"Initialize"
	changes := OrderedCollection new.
	field := self perform: aFieldName asSymbol.
	fieldDescription := (SqsStorage for: self) descriptionHandler sqsDescriptionForInstVar: aFieldName.
	(field isKindOf: OrderedCollection) ifTrue: [
		(field class includesBehavior: SqsCollectionProxy) 
		ifTrue: [ "This collection has proxied behaviour, lets work with that"
			collectionChanges := field sqsGetCollectionChangesNew.
			collectionChanges addedObjects, collectionChanges deletedObjects ifNotEmpty: [ "There are actual changes"
				collectionChanges addedObjects ifNotNilDo: [:addedObjects | 
					addedObjects do: [:map | "Changes are denoted as a tuple: (oid counter). 
						thus we need to retrieve the object that is about to be saved into this collection"
						| addedObject | 
						addedObject := field first class getFrom: {#oid -> map first}.
						changes add: (DLLogEntryChange newFrom: {
							#attributeName->aFieldName.
							#attributeValue->addedObject asString.
							#activity->#added.
							#klassName->(fieldDescription referencedClass name).
							#objectId->(addedObject oid).
							}).
					]].
				collectionChanges deletedObjects ifNotNilDo: [:deletedObjects | 
					deletedObjects do: [:map |
						| removedObject | 
						removedObject := field first class getFrom: {#oid -> map first}.
						changes add: (DLLogEntryChange newFrom: {
							#attributeName->aFieldName.
							#attributeValue->removedObject asString.
							#activity->#removed.
							#klassName->(fieldDescription referencedClass name).
							#objectId->(removedObject oid)}).
					]]]
		]
		ifFalse: [ "A non-proxied collection, self has not been saved yet"
			field isEmpty ifFalse: [
				field do: [:entry | 
				changes add: (DLLogEntryChange newFrom: {
					#attributeName->aFieldName.
					#attributeValue->entry asString.
					#activity->#added.
					#klassName->entry className.
					#objectId->entry oid
					}).
			]]
		]
	]
	ifFalse: [ "No collection, not that big deal"
		((SqsStorage for: self) dirtyAttributes includes: aFieldName)
		ifTrue: [ "TODO: Add support for foreign keys here"
			changes add: (DLLogEntryChange newFrom: {
				#attributeName->aFieldName.
				#attributeValue->field asString.
				#activity->#changed.
				#klassName->field className}).
		]
	].
	changes ifEmpty: [^ nil].
	^ changes.! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/16/2009 08:53'!
collectDependencies
	"Recursively collect all objects that depend on me or are transitively connected to this object"
	| dependencies |
	dependencies := Set with: self.
	self collectDependentObjects do: [:each | dependencies addAll: each collectDependencies].
	^ dependencies! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/26/2009 23:02'!
collectDependentObjects
	"Return an iterable list that contains all objects that depend on this object, override this method!!"
	^ {}! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/30/2009 22:42'!
currentUser
	WACurrentSession value ifNil: [^ nil] ifNotNil: [^ WACurrentSession value user].! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/29/2009 18:33'!
description
	| tempDescription |
	tempDescription := super description copy.
	self additionalDescriptions do: [:aDescription | tempDescription add: aDescription . ].
	^ tempDescription! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionAdminUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/8/2009 17:32'!
descriptionCreate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 15:48'!
descriptionDetail
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/3/2009 19:44'!
descriptionList
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/4/2009 22:47'!
descriptionUpdate
	^ self description! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserCreate
	^ self descriptionCreate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserDetail
	^ self descriptionDetail! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserList
	^ self descriptionList! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 6/13/2009 19:42'!
descriptionUserUpdate
	^ self descriptionUpdate! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 7/10/2009 16:16'!
genericCollectionAccessor: varName withArgument: anObject
		"Prevent the list from being replaced so squeaksave can always determine changed objects"
   | removedObjects addedObjects instVar |
	instVar := self instVarNamed: varName.
	(anObject class includesBehavior: SqsCollectionProxy) 
	ifTrue: [ "This message comes from SqueakSave, we like that!!" ^ self instVarNamed: varName put: anObject.].
	instVar ifNil: [instVar := OrderedCollection new].
	removedObjects := instVar difference: anObject.
	addedObjects   := anObject difference: instVar.
	removedObjects do: [:obj | instVar remove: obj].
	addedObjects   do: [:obj | instVar add: obj].
	"Save all objects so that they will have oids for the change recognition".
	"instVar   do: [:obj | obj save.]."
	^ self instVarNamed: varName put: instVar.! !

!DLModel methodsFor: 'printing' stamp: 'sebh 6/8/2009 18:02'!
printString
	^ self canonicalName ifNil: [^ super printString]! !

!DLModel methodsFor: 'as yet unclassified' stamp: 'sebh 6/13/2009 14:26'!
rightUpdate: aUser
	^ self class rightUpdate: aUser.! !

!DLModel methodsFor: 'descriptions' stamp: 'sebh 7/12/2009 03:05'!
save
	| result changes |
	changes := OrderedCollection new.
	self trackChangeVariables ifNotNil: [
		self trackChangeVariables do: [:aFieldName |
			(self changesForField: aFieldName) ifNotNilDo: [:changedValues |
					changes addAll: changedValues.
			]
		]
	].
	result := super save.
	changes isEmpty ifFalse: [
		"Has to happen after the actual save, because self oid is assigned afterwards and the save might fail for some reason"
		DLLogEntry createFrom: {
			#klassName->self className. 
			#objectId->self oid. 
			#changes->changes.
			#user->self currentUser
		}.
	].
	^ result.
! !

!DLModel methodsFor: 'descriptions' stamp: 'Marik 7/1/2009 10:03'!
trackChangeVariables
	^ {}.! !

DLModel subclass: #DLRequirement
	instanceVariableNames: 'requirementName requirementDescription filetype'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 01:01'!
descriptionRequirementDescription
	^(MAMemoDescription auto: 'requirementDescription' label:'Beschreibung' priority:20)
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 6/8/2009 00:27'!
descriptionRequirementName
	^(MAStringDescription auto: 'requirementName' label:'Title' priority:10)
		beRequired;
		yourself.! !

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:03'!
metaName
	^ 'Anforderung'! !

!DLRequirement class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Anforderungen'! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrFiletype
	^ SqsColumn new associatedClass: #DLFileType;
		 manuallyMaintained: false;
		 columnName: 'filetype_id';
		 sqlType: #integer;
		 objectClass: #DLFileType;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'filetype';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementDescription';
		 yourself! !

!DLRequirement class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRequirementName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'requirement_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_requirements';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'requirementName';
		 yourself! !

!DLRequirement methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:22'!
additionalDescriptions
	^ {self descriptionFiletype}! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 01:00'!
canonicalName
	^ self requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:22'!
descriptionFiletype
	^(MASingleOptionDescription auto: 'filetype' label:'Dateityp' priority:30)
		optionsAndLabels: (DLFileType getKeyValueSelect: [:aFile | ]);
		beRequired;
		yourself.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype

	^ filetype! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
filetype: anObject

	filetype := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription

	^ requirementDescription! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementDescription: anObject

	requirementDescription := anObject.! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName

	^ requirementName! !

!DLRequirement methodsFor: 'accessing' stamp: 'sebh 6/8/2009 00:13'!
requirementName: anObject

	requirementName := anObject.! !

DLModel subclass: #DLSemester
	instanceVariableNames: 'semesterName year'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Semester'! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrSemesterName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'semester_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'semesterName';
		 yourself! !

!DLSemester class methodsFor: 'persistence-description' stamp: ''!
sqsDescrYear
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'year';
		 sqlType: #integer;
		 objectClass: #SmallInteger;
		 tableName: 'dl_semesters';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'year';
		 yourself! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/19/2009 00:10'!
canonicalName
	^ self year asString, ' ', self semesterName.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 6/16/2009 00:14'!
collectDependentObjects
	| dependentLectures |
	dependentLectures := (SqsSearch for: DLLecture) select: [:aLecture | aLecture semester = self].
	^ dependentLectures! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName

	^ semesterName! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
semesterName: anObject

	semesterName := anObject.! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year

	^ year! !

!DLSemester methodsFor: 'accessing' stamp: 'sebh 5/20/2009 15:46'!
year: anObject

	year := anObject.! !

DLModel subclass: #DLTestItemModel
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaName
	^ 'testItem'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:37'!
metaNamePlural
	^ 'testItems'! !

!DLTestItemModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_item_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title.! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title

	^ title! !

!DLTestItemModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 22:53'!
title: anObject

	title := anObject.! !

DLModel subclass: #DLTestModel
	instanceVariableNames: 'title body items'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tests'!

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaName
	^ 'Testmodel'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: 'sebh 7/11/2009 10:36'!
metaNamePlural
	^ 'Testmodels'! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrBody
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'body';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'body';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrItems
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_test_models_items';
		 ownerColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'dl_test_model_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_models';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_test_model_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn new manuallyMaintained: false;
			 columnName: 'items_id';
			 sqlType: #integer;
			 foreignKey: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_test_item_models';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'items_id';
					 yourself);
				 yourself);
			 canBeNull: false;
			 isPrimaryKey: false;
			 autoIncrement: false;
			 linkedVariable: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLTestItemModel;
		 linkedVariable: 'items';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLTestModel class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTitle
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'title';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_test_models';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'title';
		 yourself! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body

	^ body! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 19:11'!
body: anObject

	body := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/9/2009 11:30'!
canonicalName
	^ self title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:37'!
initialize
	super initialize.
	self items: OrderedCollection new.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
items

	^ items! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/10/2009 16:13'!
items: anObject
	^ self genericCollectionAccessor: 'items' withArgument: anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title

	^ title! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 6/27/2009 18:36'!
title: anObject

	title := anObject.! !

!DLTestModel methodsFor: 'accessing' stamp: 'sebh 7/7/2009 23:01'!
trackChangeVariables
	^ {'title'. 'items'}.! !

DLModel subclass: #DLTopic
	instanceVariableNames: 'topicName topicDescription lecture students'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLTopic class methodsFor: 'persistence-description' stamp: 'MG 7/13/2009 17:00'!
descriptionMail
	^ (DLMAMailDescription auto: 'mail' label: 'E-Mail' priority: 140)
			reportColumnClass: DLMALinkColumnMail;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLTopic class methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:09'!
descriptionTopicDescription
	^ (MAMemoDescription auto: 'topicDescription' label: 'Beschreibung' priority: 20)
			yourself.
! !

!DLTopic class methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:09'!
descriptionTopicName
	^ (MAStringDescription auto: 'topicName' label: 'Thema' priority: 10)
			beRequired;
			yourself.
! !

!DLTopic class methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 17:02'!
metaName
	^ 'Thema'! !

!DLTopic class methodsFor: 'as yet unclassified' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Themen'! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrLecture
	^ SqsColumn new associatedClass: #DLLecture;
		 manuallyMaintained: false;
		 columnName: 'lecture_id';
		 sqlType: #integer;
		 objectClass: #DLLecture;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'lecture';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrMail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'mail';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'mail';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrStudents
	^ SqsCollectionDescription new manuallyMaintained: false;
		 collectionClass: #OrderedCollection;
		 tableName: 'dl_topics_students';
		 ownerColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'dl_topic_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_topics';
				 updateActions: #();
				 deleteActions: (OrderedCollection new add: #CASCADE;
					 yourself);
				 referencingColumns: (Set new add: 'dl_topic_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSOWNER;
			 yourself);
		 referenceColumn: (SqsColumn basicNew instVarAt: 1 put: nil;
			 instVarAt: 2 put: false;
			 instVarAt: 3 put: 'students_id';
			 instVarAt: 4 put: #integer;
			 instVarAt: 5 put: nil;
			 instVarAt: 6 put: nil;
			 instVarAt: 7 put: (SqsForeignKeyDescription new manuallyMaintained: false;
				 referencedColumns: (Set new add: 'id';
					 yourself);
				 referencedTable: 'dl_users';
				 updateActions: #();
				 deleteActions: #(#CASCADE );
				 referencingColumns: (Set new add: 'students_id';
					 yourself);
				 yourself);
			 instVarAt: 8 put: false;
			 instVarAt: 9 put: false;
			 instVarAt: 10 put: false;
			 instVarAt: 11 put: #SQSREF;
			 yourself);
		 maintainOrder: true;
		 simpleValues: false;
		 indexType: #integer;
		 referencedClass: #DLUser;
		 linkedVariable: 'students';
		 orderField: 'sqs_order_number';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicDescription
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_description';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicDescription';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicName';
		 yourself! !

!DLTopic class methodsFor: 'persistence-description' stamp: ''!
sqsDescrTopicPhase
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'topic_phase';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_topics';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'topicPhase';
		 yourself! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 16:51'!
addStudent: aUser
	self students addIfNotPresent: aUser.
	self save.! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'Marik 7/12/2009 14:24'!
additionalDescriptions
	^ {self descriptionStudents.self descriptionLecture}! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'caro 6/26/2009 01:20'!
canonicalName
	^ self topicName! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'caro 7/3/2009 22:08'!
collectDependentObjects
	|dependentGroups |
	dependentGroups 	 := (SqsSearch for: DLGroup)    select: [:aGroup 	 | aGroup 	 lecture = self].
	^ dependentGroups.! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'MG 7/13/2009 17:13'!
descriptionCreate
 ^ self description select: [:each | #(topicName topicDescription students lecture) includes: each accessor selector]! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'MG 7/13/2009 17:14'!
descriptionDetail
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'Marik 7/12/2009 14:23'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture |]);
			beRequired;
			yourself.! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'MG 7/13/2009 16:59'!
descriptionList
 ^ self description select: [:each | #(topicName topicDescription students lecture mail) includes: each accessor selector]! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'Marik 7/12/2009 14:23'!
descriptionStudents
	^ (MAMultipleOptionDescription auto: 'students' label: 'Studenten' priority: 30)
		 	optionsAndLabels: (DLUser getKeyValueSelect: [:aUser | ]);
			yourself.
! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'MG 7/13/2009 17:13'!
descriptionUpdate
 ^ self descriptionCreate! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'caro 6/28/2009 16:40'!
initialize
	super initialize.
	self students: OrderedCollection new.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
lecture

	^ lecture! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
lecture: anObject

	lecture := anObject.! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'MG 7/13/2009 17:00'!
mail

	| linkCollection |
	linkCollection := OrderedCollection new.
	self students do:[:each| linkCollection add: (each email)].
	^ 'mailto:',(linkCollection join: ',').! !

!DLTopic methodsFor: 'as yet unclassified' stamp: 'caro 6/25/2009 16:59'!
removeStudent: aUser
	self students remove: aUser ifAbsent: ["Somehow the user was removed. Result is the same."].
	self save.
! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students

	^ students! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
students: anObject

	students := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription

	^ topicDescription! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicDescription: anObject

	topicDescription := anObject.! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName

	^ topicName! !

!DLTopic methodsFor: 'accessing' stamp: 'caro 6/25/2009 16:59'!
topicName: anObject

	topicName := anObject.! !

DLModel subclass: #DLUser
	instanceVariableNames: 'userName realName email isAdmin isTeacher isAssistant isStudentAssistant'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-models'!

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 7/14/2009 11:16'!
descriptionEmail
	^ (MAStringDescription auto: 'email' label: 'E-Mail' priority: 30)
			addCondition: [:anEmail | anEmail matchesRegexIgnoringCase: '[A-Za-z0-9._-]+@([A-Za-z0-9._-]+\.)?hpi.uni-potsdam.de'] labelled: 'Muss eine gltige HPI-E-Mail-Adresse sein.';
			comment: 'Eine gltige HPI-E-Mail-Adresse.';
			reportColumnClass: DLMALinkColumnMail;
			componentClass: DLMALinkComponent;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/13/2009 15:10'!
descriptionIsAdmin
	^ (MABooleanDescription auto: 'isAdmin' label: 'Administrator' priority: 30)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:44'!
descriptionIsAssistant
	^ (MABooleanDescription auto: 'isAssistant' label: 'Assistent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/24/2009 12:13'!
descriptionIsStudentAssistant
	^ (MABooleanDescription auto: 'isStudentAssistant' label: 'Studentischer Assistent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 6/7/2009 18:07'!
descriptionIsTeacher
	^ (MABooleanDescription auto: 'isTeacher' label: 'Dozent' priority: 40)
			default: false;
			yourself.
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/4/2009 13:51'!
descriptionRealName
		^ (MAStringDescription auto: 'realName' label: 'Name' priority: 20)
			beRequired;
			yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/2/2009 23:06'!
descriptionUserName
		^ (MAStringDescription auto: 'userName' label: 'Benutzername' priority: 10)
			beRequired;
			yourself.
		
! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 6/6/2009 23:35'!
metaName
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'sebh 7/3/2009 00:04'!
metaNamePlural
	^ 'Benutzer'! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:23'!
sqsDescrEmail
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'email';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'email';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAdmin
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_admin';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAdmin';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_assistant';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsStudentAssistant
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_student_assistant';
		 sqlType: #boolean;
		 objectClass: #False;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isStudentAssistant';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrIsTeacher
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'is_teacher';
		 sqlType: #boolean;
		 objectClass: #True;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'isTeacher';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: ''!
sqsDescrRealName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'real_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'realName';
		 yourself! !

!DLUser class methodsFor: 'persistence-description' stamp: 'Marik 5/27/2009 10:24'!
sqsDescrUserName
	^ SqsColumn new manuallyMaintained: false;
		 columnName: 'user_name';
		 sqlType: #string;
		 objectClass: #ByteString;
		 tableName: 'dl_users';
		 canBeNull: true;
		 isPrimaryKey: false;
		 autoIncrement: false;
		 linkedVariable: 'userName';
		 yourself! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:24'!
additionalDescriptions
	^ {self descriptionLecture}! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/8/2009 18:06'!
canonicalName
	^ self realName ifNil: [^ self userName]! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 7/2/2009 23:07'!
descriptionCreate
 ^ self description select: [:each | #(userName realName email isAdmin isAssistant isStudentAssistant isTeacher) includes: each accessor selector]! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 7/12/2009 14:25'!
descriptionLecture
	^ (MASingleOptionDescription auto: 'lecture' label: 'Vorlesung' priority: 10)
			optionsAndLabels: (DLLecture getKeyValueSelect: [:aLecture | ]);
			beRequired;
			yourself.
! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 7/2/2009 17:39'!
descriptionList
 ^ self description select: [:each | #(userName realName email) includes: each accessor selector]! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 6/13/2009 19:43'!
descriptionUserUpdate
 ^ self description select: [:each | #(userName realName email) includes: each accessor selector]! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email

	^ email! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/27/2009 10:17'!
email: anObject

	email := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/17/2009 13:38'!
groupForLecture: aLecture
	^ (SqsSearch for: DLGroup) detect: [:aGroup | (aGroup students includes: self) & (aGroup lecture = aLecture)] ifNone: [nil].! !

!DLUser methodsFor: 'initialize-release' stamp: 'sebh 6/9/2009 13:59'!
initialize
	super initialize.
	self isAdmin: false.
	self isAssistant: false.
	self isStudentAssistant: false.
	self isTeacher: false.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/3/2009 17:34'!
isAdmin
	^ isAdmin! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 5/27/2009 23:08'!
isAdmin: anObject

	isAdmin := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant

	^ isAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:36'!
isAssistant: anObject

	isAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant

	^ isStudentAssistant! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/9/2009 13:58'!
isStudentAssistant: anObject

	isStudentAssistant := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher

	^ isTeacher! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:35'!
isTeacher: anObject

	isTeacher := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/26/2009 23:09'!
lectures
	| temp |
	temp := (SqsSearch for: DLLecture) select: [:lecture | lecture students includes: self].
	^ temp.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/26/2009 23:20'!
lectures: aCollection
	| lecturesBefore lecturesRemove lecturesAdd |
	lecturesBefore := self lectures.
	lecturesRemove := lecturesBefore difference: aCollection.
	lecturesAdd    := aCollection difference: lecturesBefore.
	lecturesRemove do: [:lecture | lecture students remove: self. lecture save.].
	lecturesAdd    do: [:lecture | lecture students add: self.    lecture save.].! !

!DLUser methodsFor: 'initialize-release' stamp: 'Marik 7/14/2009 11:17'!
mail

	^ 'mailto:',self email.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName

	^ realName! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/4/2009 12:37'!
realName: anObject

	realName := anObject.! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/13/2009 14:30'!
rightUpdate: aUser
	^ (aUser = self) | (super rightUpdate: aUser)! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:40'!
topicForLecture
 ^'foo'! !

!DLUser methodsFor: 'accessing' stamp: 'cr 7/8/2009 16:43'!
topicForLecture: aLoo
 ^nil! !

!DLUser methodsFor: 'accessing' stamp: 'sebh 6/30/2009 14:29'!
trackChangeVariables
	^ {'isAdmin'.'isTeacher'.'isAssistant'.'realName'}! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName

	^ userName! !

!DLUser methodsFor: 'accessing' stamp: 'Marik 5/26/2009 13:25'!
userName: anObject

	userName := anObject.! !

Object subclass: #Tutorials
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-tutorial'!

!Tutorials methodsFor: 'as yet unclassified' stamp: 'Marik 7/13/2009 16:14'!
DatabaseFixture
	| semester lecture lecture2 deadline deadlineCoding user userJack userJohn userBehrens userGoetz group groupJack session userChr userAss1 userAss2 studentSet filetype filetypeCoding requirement requirementCoding requirementCoding2 userMichaelHaupt |
	
	session := SqsConnectionManager getInstance sessionForClass: DLUser.
	session resetDatabase.
	
	{2009. 2010. 2011} do: [:each | 
		DLSemester new
			semesterName: 'Sommer';
			year: each;
			save.
		DLSemester new
			semesterName: 'Winter';
			year: each;
			save.
	].

	semester := (SqsSearch for: DLSemester) detect: 
	[:aSemester |( aSemester semesterName = 'Sommer') & (aSemester year = 2009)].

	user := DLUser createFrom: {
		#userName->'Sebastian.Hillig'.
		#realName->'Sebastian Hillig'. 
		#email->'Sebastian.Hillig@student.hpi.uni-potsdam.de'}.
		
	userBehrens := DLUser createFrom: {
		#userName->'Markus.Behrens'.
		#realName->'Markus Behrens'. 
		#email->'Markus.Behrens@student.hpi.uni-potsdam.de'}.

	userGoetz := DLUser createFrom: {
		#userName->'Markus.Goetz'.
		#realName->'Markus Goetz'. 
		#email->'Markus.Goetz@student.hpi.uni-potsdam.de'}.		

	userChr := DLUser createFrom: {
		#userName->'christian.ress'. 
		#realName->'Christian Ress'. 
		#email->'christian.ress@student.hpi.uni-potsdam.de'}.
	
	userMichaelHaupt := DLUser createFrom: {
		#userName->'michael.haupt'.
		#realName->'Michael Haupt'.
		#email->'michael.haupt@hpi.uni-potsdam.de'
	}.
	
	userJack := DLUser createFrom: {
		#userName->'jack'. 
		#realName->'Jack Johnson'. 
		#email->'jack@hpi.uni-potsdam.de'. 
		#isAdmin->true. 
		#isTeacher->true}.
		
	userJohn := DLUser createFrom: {
		#userName->'john'. 
		#email->'john@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
		
	userAss1 := DLUser createFrom: {
		#userName->'assistent1'. 
		#email->'assistent1@hpi.uni-potsdam.de'.
		#isAssistant->true}.
		
	userAss2 := DLUser createFrom: {
		#userName->'assistent2'. 
		#email->'assistent2@hpi.uni-potsdam.de'. 
		#isAssistant->true}.
	
	studentSet := OrderedCollection new add: userChr; yourself.
	
	lecture := DLLecture new
		lectureName: 'Softwaretechnik I';
		lectureDescription: 'An introduction to techniques in software development';
		lectureHomepage: 'http://www.hpi.uni-potsdam.de/studium/lehrangebot/veranstaltung/softwaretechnik_i-3.html';
		mailingList: 'swt@fakeurl.com';
		teacher: userJack;
		semester: semester;
		students: studentSet;
		save.
		
	lecture2 := DLLecture new
		lectureName: 'Softwarearchitektur';
		lectureHomepage: 'http://www.hpi.uni-potsdam.de/studium/lehrangebot/lehrangebotsarchiv/lehrangebotsarchiv_ws_0809/veranstaltung/softwarearchitektur-3.html';
		lectureDescription: 'An introduction to basic architecture principles';
		mailingList: 'fake@swafake.tv';
		semester: semester;
		students: studentSet copy;
		save.
	
	filetype := DLFileType createFrom: {
		#filetypeName->'Prsentation'. 		
		#extensionsText->'.pdf,.ppt,.pptx'}.
		
	filetypeCoding  := DLFileType createFrom: {
		#filetypeName->'Codedateien'. 		
		#extensionsText->'.sar, .cpp'}.
	
	requirement := DLRequirement createFrom:{
		#requirementName->'Prsentation'. 		
		#requirementDescription->'Auseinandersetzung mit Interteamrelationships in hyperaktiven Teams'. 
		#filetype->filetype}.
		
	requirementCoding := DLRequirement createFrom:{
		#requirementName->'Codeabgabe'. 		
		#requirementDescription->'Bitte gebt die .sar eures Projekts ab'. 
		#filetype->filetypeCoding}.
	
	requirementCoding2 := DLRequirement createFrom:{
		#requirementName->'Codedokumentation'. 		
		#requirementDescription->'Bitte gebt die Dokumentation des Projekts ab'. 
		#filetype->filetype}.
	
	deadline := DLDeadline createFrom: {
		#lecture-> lecture.
		#group-> nil.
		#deadlineName-> 'Vortragsfolien'. 
		#deadlineDescription-> 'Bitte gebt eure Folien fr euren Kurzvortrag ab'.
		#date->(Date today). 
		#time->(Time now addTime: (Time hour: 0 minute: 60 second: 0)). 		
		#requirements->(OrderedCollection with: requirement)}.

	deadlineCoding := DLDeadline createFrom: {
		#lecture-> lecture.
		#group-> nil.
		#deadlineName-> 'Projektabgabe'. 
		#deadlineDescription-> 'Bitte gebt alle Codedateien eures Projekts ab.'.
		#date->(Date year: 2009 month: 7 day: 30). 
		#time->(Time hour: 23 minute: 59 second:59). 		
		#requirements->(OrderedCollection with: requirementCoding with: requirementCoding2)}.
	
	{'DevChat #1'. 'DevChat #2'. 'Accounting System'. 'Submitting System #2'. 'FileBrowser on Steroids'. 'LiveChat'. 'iKuh Leveleditor'. 'Telefonbuch #1'} do: [:each |
		DLGroup createFrom: {
			#groupName->each.
			#lecture->lecture.
			#groupDescription->'SWT-Beispielgruppe'.
		}.
	].
	
	
	{'Connect!!'. 'DabbleDB'. 'SqueakSource Impro'. 'OODB!!'} do: [:each |
		DLGroup createFrom: {
			#groupName->each.
			#lecture->lecture2.
			#groupDescription->'SWA-Beispielgruppe'.
		}.
	].
	
	group := DLGroup new
		groupName: 'SWT Crew 09';
		groupDescription: 'A SWT Group';
		lecture: lecture;
		students: ( {user} as: OrderedCollection );
		save.
		
	groupJack := DLGroup new
		groupName: 'Jacks SWT Group';
		groupDescription: 'Owner: Jack Johnson';
		lecture: lecture;
		students: ( OrderedCollection with: userJack with: userChr);
		save.! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/2/2009 13:50'!
HowToResetYourDB

"session := SqsConnectionManager getInstance sessionForClass: DLUser.
session resetDatabase.
"! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'MG 6/29/2009 00:29'!
SendingEMailsWithSqueak

"|username password sender receiver|

username:= 'smtp_user_name'.
password:='smtp_password'.

sender := sender@test.de.
receiver := receiver@test.de.

client := SMTPClient openOnHostNamed: '<smtp_host>' port: <smtp_port, default: 25>.
client 	user: username;
			password: password;
client   login;
			initiateSession.
client 	mailFrom: sender;
 			recipient: receiver;
 			data:	'Subject: <Betreff>
			From: <Sender-Label>
			To: <Empfaenger-Label>
			
			Kleiner E-Mail-Test'.
client quit.

--------------------------------------------------------
Kleines Beispiel mit Test-SMTP-Acc auf Christians SMTP
--------------------------------------------------------

username:= 'squeaky'.
password:='jflymcv98yM'.

client := SMTPClient openOnHostNamed: 'darwin.yetisoft.net' port: 25.
client user: username; password: password; login; initiateSession.
client mailFrom: 'squeaky@darwin.yetisoft.net';
 	recipient: 'markus.goetz@student.hpi.uni-potsdam.de';
 	data:	'Subject: Hello from SMTPClient!!
			From: squeaky@darwin.yetisoft.net
			To: murxman@web.de
			
			Kleiner E-Mail-Test'.
client quit."! !

!Tutorials methodsFor: 'as yet unclassified' stamp: 'sebh 6/3/2009 22:57'!
WhatToInstall
"
Von SqueakMap: Magritte 1.1.1

Announcements
MCHttpRepository
	location: 'http://source.lukas-renggli.ch/announcements'
	user: ''
	password: ''

SqsSave im Monticello updaten.

DatabaseFixture aus den Tutorials ziehen und in einem Workspace ausfhren.

Im Seaside Admin:
	Add new entry
	'deli', Application
	RootComponent DLRootTask
	SessionComponent DLSession

Benutzer aus dem fixture und mit beliebigem passwort nutzbar:
	jack - admin
	john - user
"! !

MADescribedColumn subclass: #DLMAChangesColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAChangesColumn methodsFor: 'as yet unclassified' stamp: 'sebh 7/12/2009 03:00'!
renderCellContent: anObject on: html
	|  changes |
	changes := (self valueFor: anObject).
	html definitionList: [
		changes do: [:aChange | 
			html definitionTerm: aChange attributeName.
			html definitionData: [
				html text: aChange attributeValue.
				((aChange klass) includesBehavior: DLModel) ifTrue:[
				html text: aChange objectId.
				html anchor
					callback: [self report call: (DLAdminDetailComp for: ((aChange klass) getFrom: {#oid->aChange objectId}))];
					text: '[here]'.
				]
			]
		] 
	]! !

MADescribedColumn subclass: #DLMAKeyValueColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAKeyValueColumn methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 00:59'!
renderCellContent: anObject on: html
	|  kv |
	kv := (self valueFor: anObject).
	html definitionList: [
		kv do: [:aPair | 
			html definitionTerm: aPair key.
			html definitionData: aPair value.
		] 
	]! !

MADescribedColumn subclass: #DLMALinkColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkColumn methodsFor: 'as yet unclassified' stamp: 'cr 7/13/2009 14:04'!
renderCellContent: anObject on: html
	html withUrls: anObject lectureHomepage.! !

DLMALinkColumn subclass: #DLMALinkColumnMail
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMALinkColumnMail methodsFor: 'as yet unclassified' stamp: 'Marik 7/13/2009 15:57'!
renderCellContent: anObject on: html

	html anchor url: anObject mail; with: 'E-Mail versenden'.
! !

MADescribedColumn subclass: #DLMATruncatedStringColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMATruncatedStringColumn methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 23:41'!
renderCellContent: anObject on: html
	html render: ((self description toString: (self valueFor: anObject)) truncateWithElipsisTo: 100).! !

MACommandColumn subclass: #DLMAConditionalCommandColumn
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'MG 7/1/2009 15:48'!
addCommand: aCommand condition: aCondition text: aText
	self commands add: aCondition -> (aCommand -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'sebh 7/1/2009 16:18'!
addCommand: aCommand condition: aCondition text: aText classed: aClass
	self commands add: aCondition -> (aCommand -> (aText -> aClass)).! !

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'MG 7/1/2009 15:51'!
addCondition: aCondition text: aText
	self commands add: aCondition -> (nil -> (aText -> nil)).! !

!DLMAConditionalCommandColumn methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 17:43'!
renderCellLinkContent: anObject on: html
	self commands
		do: [ :each |
			| condition block text cssClass |
			condition := each key. block := each value key. text := each value value key. cssClass := each value value value.
			(condition value: anObject)
			ifTrue:[
				(block isNil)
				ifTrue:  [ html text: text. ]
				ifFalse: [ 
					html div class: cssClass; with: [
								html anchor
								callback: [ block value: anObject ];
								with: text]
					].
			]]
		! !

SqsConfig subclass: #DeliSqsConfig
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DeliSqsConfig class methodsFor: 'as yet unclassified' stamp: 'sebh 6/15/2009 23:04'!
configuration
	| config |
	config := super configuration.
	
	config
		warnOnAlteration: false.

	^ config.! !

!DeliSqsConfig class methodsFor: 'as yet unclassified' stamp: 'cr 6/9/2009 14:41'!
connectionSpecification
	^ SqsMySQLConnectionSpecification 
		user: 'root'
		password: ''
		database: 'deli'
		port: 3306
		host: 'localhost'! !

Error subclass: #DLMultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNilValueException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #DLNoResultException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

Error subclass: #MultipleResultsException
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

WAApplication subclass: #DLApplication
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLApplication class methodsFor: 'as yet unclassified' stamp: 'test 6/14/2009 15:22'!
description
	^ 'DLApplication'! !

!DLApplication methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 21:37'!
initialize
	super initialize.
	self addLibrary: DLFileLibrary.
	self addLibrary: SULibrary.
	self preferenceAt: #mainClass    	 put: DLAuthMain.
	self preferenceAt: #sessionClass 	 put: DLSession.
	self preferenceAt: #useSessionCookie put: true.
	self preferenceAt: #rootComponent    put: DLRootComponent.! !

WAFileLibrary subclass: #DLFileLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-configuration'!

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'cr 6/1/2009 01:16'!
selectorsToInclude

	^ Array with: 'styleCss'! !

!DLFileLibrary methodsFor: 'uploaded' stamp: 'sebh 7/2/2009 23:59'!
styleCss
	^'
body {
	font-family: "Trebuchet MS",sans-serif;
	font-size: 0.85em;
	padding: 0 0 0 0;
	margin: 0 0 0 0;
}

#lightbox {
	background-color: #fff;
	padding: 10px;
	-moz-border-radius: 5px;
	-webkit-border-radius: 5px;
}

#lightbox form dl {
	margin-bottom: 5px;
	padding-bottom:5px;
}

.header {
	width: 100%;
	background-color: #df6824;
	height:100px;
	border-bottom: 5px solid #dfa27f;
}

.header img {
	padding:5px;
	float:left;
}

.footer {
	width:100%;
	height:20px;
	position:fixed;
	bottom:0px;
}

.menu {
	float:left;
	margin-top: 5px;
}

.menu ul {
	clear: both;
}

.menu li {
	float: left;
	list-style:none;
	padding: 0 2px 0 2px;
}

.menu a {
	background-color: #fff;
	text-decoration: none;
	font-weight: bold;
	line-height: 30px;
	padding: 3px;
	color: #df6824;
}

table caption, h2 {
	font-size: 18pt;
}

.odd { background-color: #fadbab; }
.even{ background-color: #fff }

dl{
	margin:15px 0px 0px 0px;
	padding:0px;
	width:auto;
	clear:both;
}
	
dt{
	float:left;
	width:160px;
	margin:0px 0px 5px 0px;
}
	
dd{
	margin:0px 0px 10px 160px;
	color:#666666;
	text-indent:-3px !!important;
}

dd:empty:after {
	content:".";
	color:#fff;
}

	
dd label{
	vertical-align:top;
	margin:0px 8px 0px 0px;
	line-height:1.6em;
	}


.buttons {
	float:left;
}

.warning, 
.over {
}

.warning {
	background-color: #fc0;
}

.over { background-color: #df2424; }
.over a { color: #fff; padding:3px; }

.content {
	margin-top: 25px;
	margin-bottom: 50px;
	margin-left: 90px;
}

.content td, .content th {
	padding: 3px;
}

.content dt.required {
	font-weight: bold;
}

.helptext {
	font-size: 10px;
	color: #777;
}
.graph { 
        position: relative;
        width: 275px; 
        border: 1px solid #B1D632; 
        padding: 2px; 
    }
.graph .bar { 
        display: block;
        position: relative;
        background: #B1D632; 
        text-align: center; 
        color: #333; 
        height: 2em; 
        line-height: 2em;            
    }
.graph .bar span { position: absolute; left: 1em; }


'! !

!DLFileLibrary methodsFor: 'as yet unclassified' stamp: 'sebh 7/2/2009 21:50'!
updateRoot:	anHtmlRoot
	anHtmlRoot stylesheet url: 'http://yui.yahooapis.com/2.7.0/build/reset/reset-min.css'.
	super updateRoot: anHtmlRoot.
	! !

MAFileUploadComponent subclass: #DLMADeliverableFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMADeliverableFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:35'!
isMultipart
	^ true! !

!DLMADeliverableFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
renderEditorOn: html
	self value isNil
		ifTrue:  [ self renderUploadOn: html ]
		ifFalse: [ self renderReplaceOn: html ]! !

!DLMADeliverableFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
renderReplaceOn: html
	html anchor
		url: (self value urlOn: html);
		with: self value filename.
	html text: ' ('; render: self value filesize asFileSize; text: ') '.
	
	html fileUpload
		id: self labelId;
		on: #replace of: self.
	html submitButton
		text: 'replace'.! !

!DLMADeliverableFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/17/2009 02:36'!
replace: aFile
	aFile notNil ifTrue:[ 
		self value finalize.
		self value: nil.
		self upload: aFile.
	].
	! !

!DLMADeliverableFileUploadComponent methodsFor: 'as yet unclassified' stamp: 'sebh 6/19/2009 00:09'!
upload: aFile
	self value: (aFile isNil ifFalse: [
		self description kind new
			mimetype: aFile contentType;
			filename: aFile fileName;
			location: {
				memento model delivery deadline lecture semester canonicalName. 
				memento model delivery deadline lecture lectureName. 
				memento model delivery deadline canonicalName. 
				memento model delivery group canonicalName
				};
			contents: aFile contents;
			yourself ])! !

MAReport subclass: #DLMAGroupedReport
	instanceVariableNames: 'groupField'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField

	^ groupField! !

!DLMAGroupedReport methodsFor: 'accessing' stamp: 'sebh 6/21/2009 00:26'!
groupField: anObject

	groupField := anObject.! !

!DLMAGroupedReport methodsFor: 'as yet unclassified' stamp: 'sebh 6/21/2009 00:23'!
renderTableBodyOn: html 
	self visible isEmpty 
		ifTrue: [ 
			html tableRow
				class: 'empty';
				with: [ 
					html tableData
						colSpan: self visibleColumns size;
						with: self tableEmpty ] ]
		ifFalse: [
			| grouping |
			grouping := Dictionary new.
			self visible keysAndValuesDo: [ :index :row |
				| groupstring |
				groupstring := (row perform: self groupField) asString.
				grouping at: groupstring ifAbsentPut: OrderedCollection new.
				(grouping at: groupstring) add: row.
				].
			grouping keysAndValuesDo: [ :head :groupedrows |
				html tableRow class:'grouping'; with: [ html tableData: head].
				groupedrows keysAndValuesDo: [ :index :row | 
				html tableRow
					class: (self rowStyleForNumber: index);
					with: [ 
						self visibleColumns do: [ :col | 
							col 
								renderCell: row
								index: index
								on: html ] ] ] ] ]! !

MAStringDescription subclass: #DLMAMailDescription
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Deli-util'!

!DLMAMailDescription methodsFor: 'as yet unclassified' stamp: 'Marik 7/13/2009 16:05'!
isSortable

	^ false! !
